/* launch it after the last cu..-program and before ctyset1.prg */

@ program ctyagg1 @

/* aggregates cu-specific data into county-specific data */

new; #lineson;
save path=d:\data\cu1\gauss;
output file=c:\prg\cu1\ctyagg1.out reset;
str=datestr(0);
tr=timestr(0);
"GAUSS                            time  ";; tr;; "  date (US) ";; str;
?;"input file: ctyagg1.prg";?;

@ read data @

dtset1="merge22";
dtset2="years";
dtset3="states";
dtset4="tcodes";
dtset5="d:\\data\\cu1\\gauss\\anndat";

dos pkunzip -3 -) d:\data\cu1\gauss\years.zip c:\prg\cu1;
dos pkunzip -3 -) d:\data\cu1\gauss\merge22.zip c:\prg\cu1;
dos pkunzip -3 -) d:\data\cu1\gauss\states.zip c:\prg\cu1;
dos pkunzip -3 -) d:\data\cu1\gauss\tcodes.zip c:\prg\cu1;

@ read data @

open f1=^dtset1 for read;
rw1=rowsf(f1);
dat_=readr(f1,rw1);
f1=close(f1);
clear f1;

open f2=^dtset2 for read;
rw2=rowsf(f2);
years=readr(f2,rw2);
f1=close(f2);
clear f2;
years=years[.,3:cols(years)]; @ drop lead columns (first two columns) @

open f3=^dtset3 for read;
rw3=rowsf(f3);
states=readr(f3,rw3);
f3=close(f3);
clear f3;
states=states[.,4:cols(states)]; @ drop lead columns (first three columns) @

open f4=^dtset4 for read;
rw4=rowsf(f4);
tcodes=readr(f4,rw4);
f4=close(f4);
clear f4;
/*
tcodes=tcodes[.,4:cols(tcodes)]; @ drop lead columns (first three columns) @
*/
if sumc(sumc(tcodes[.,4:cols(tcodes)])) ne rows(tcodes[.,4:cols(tcodes)]);
"ERROR in tom codes - wait"; wait;
endif;

open f5=^dtset5 for read;
rw5=rowsf(f5);
anndat=readr(f5,rw5); @ annual data; no lead columns @
f1=close(f5);
clear f5;

@------------------------------------@

dat=dat_~years~states~anndat;
colsdat_=cols(dat_);
rowsdat_=rows(dat_);
/* clear dat_;

ctys=unique(dat[.,8],1); @ counties in dataset; take FIPS code @
yrs =unique(dat[.,1],1); @ years that show @
format /rd 6,0;

"number or years in dataset: " rows(yrs);
"number or counties in dataset: " rows(ctys);
"maximum number of rows of new dataset: " rows(ctys).*rows(yrs);

@ aggregate @

mat=-9.*ones(rows(yrs).*rows(ctys),cols(dat));

diff=0; @ counts # of missing counties @
j=0;
do while j<rows(yrs); @ go over years @
j=j+1;

crit1=(dat[.,1].==yrs[j]);
yrsmat=selif(dat,crit1);    @ dataset @
yrstco=selif(tcodes,crit1); @ tom codes @
clear crit1;

i=0;
do while i<rows(ctys); @ go over counties @
i=i+1;

crit2=(yrsmat[.,8].==ctys[i]);

if sumc(crit2).>0;
  ctymat=selif(yrsmat,crit2); @ dataset @
  ctytco=selif(yrstco,crit2); @ tom codes @
  clear crit2;
  ctytco=ctytco[.,4:cols(ctytco)]; @ drop lead columns (first three columns) @
  if cols(ctytco) ne 10; "error (7) -- wait"; wait; endif;
  k=(j-1).*rows(ctys)+i; @ position in matrix mat @
  mat[k,.]=ctymat[1,.]; @ any row of ctymat is fine @

  @ weighted participation rate by county @
  weights=ctymat[.,10]./sumc(ctymat[.,10]); @ based on potential members @
  partrat=ctymat[.,9]./ctymat[.,10];
  pr=sumc(weights.*partrat);
  @ format /rd 10,4; pr; @
  if pr.>1; "error (3a) -- wait"; wait; endif;
  mat[k,9]=pr;

  @ lagged weighted participation rate by county @
  weights=ctymat[.,33]./sumc(ctymat[.,33]); @ based on lagged pot. members @
  partrat=ctymat[.,32]./ctymat[.,33];
  pr=sumc(weights.*partrat);
  @ format /rd 10,4; pr; @
  if pr.>1; "error (3b) -- wait"; wait; endif;
  mat[k,12]=pr;

  @ weighted fraction of multi-group cus @
  weights=ctymat[.,10]./sumc(ctymat[.,10]); @ based on potential members @
  mg=sumc(ctytco[.,4:6 9:10]'); @ multiple group dummy @
  pr=sumc(weights.*(mg./rows(mg)));
  @ format /rd 10,4; pr; @
  if pr.>1; "error (4) -- wait"; wait; endif;
  mat[k,10]=pr;

  @ un-weighted fraction of multi-group cus @
  weights=ctymat[.,10]./sumc(ctymat[.,10]); @ based on potential members @
  mg=sumc(ctytco[.,4:6 9:10]'); @ multiple group dummy @
  pr=sumc(mg)./rows(mg);
  @ format /rd 10,4; pr; @
  if pr.>1; "error (4) -- wait"; wait; endif;
  mat[k,11]=pr;
else; diff=diff+1;
endif; @ crit 2 @

endo; @ counties @
format /rd 4,0; "percent done:" (j./rows(yrs)).*1e2;
endo; @ years @

@ balanced / unbalanced @

if diff ne 0; format /rd 4,0;
"panel is unbalanced " diff;; "county-years are missing";
else; "panel is balanced"; endif;

@ sort datset @
@ Observations get stacked like this:
                                          1993  firm1 (=county1)
                                          1992
                                          1991
                                          ....  ...
                                          1993  firm2 (=county2)
                                          1992
                                          1991
                                          ....  ...  @

mat[.,2]=-mat[.,2];
mat=rev(sortmc(mat,2|1));
mat[.,2]=-mat[.,2];
?;?;mat[.,1 2];

@ eliminate missing data @

crit=(mat[.,1].==-9);
if sumc(crit) ne diff; "error (8) -- wait"; wait; endif;

format /rd 8,0;
"# of rows before eliminating missing data:" rows(mat);
mat=delif(mat,crit);
"# of rows after eliminating missing data:" rows(mat);

@ eliminate lagged herfindahl values of one @

crit=(mat[.,37].==1);
format /rd 8,0;
"# of rows before eliminating lagged unit herfs:" rows(mat);
mat=delif(mat,crit);
"# of rows after eliminating lagged unit herfs:" rows(mat);

@ eliminate herfindahl values of one @

crit=(mat[.,36].==1);
format /rd 8,0;
"# of rows before eliminating unit herfs:" rows(mat);
mat=delif(mat,crit);
"# of rows after eliminating unit herfs:" rows(mat);

@ eliminate lagged participation rates of one @

crit=(mat[.,12].==1);
format /rd 8,0;
"# of rows before eliminating unit lagged participation rates:" rows(mat);
mat=delif(mat,crit);
"# of rows after eliminating unit lagged participation rates:" rows(mat);

@ eliminate participation rates of one @

crit=(mat[.,9].==1);
format /rd 8,0;
"# of rows before eliminating unit participation rates:" rows(mat);
mat=delif(mat,crit);
"# of rows after eliminating unit participation rates:" rows(mat);

@ save new datasets: have two lead columns (year; cu#) @

merge22_=mat[.,1:colsdat_];
years_  =mat[.,1:2 colsdat_+1:colsdat_+cols(years)];
states_ =mat[.,1:2 colsdat_+1+cols(years):colsdat_+cols(years)+cols(states)];

         r3=colsdat_+1+cols(years)+cols(states);
         r4=colsdat_+cols(years)+cols(states)+cols(anndat);
anndat_ =mat[.,1:2 r3:r4];

if r4 ne cols(mat); "error (5) -- wait"; wait;
else; clear dat;
endif;

ctys=unique(merge22_[.,8],1); @ counties in dataset; take FIPS code @
yrs =unique(merge22_[.,1],1); @ years that show @
format /rd 6,0;

"number or years in dataset: " rows(yrs);
"number or counties in dataset: " rows(ctys);
"number of rows of new dataset: " rows(merge22_);

save merge22_,years_,states_,anndat_;
    */
end;
