@ Programm ctyiv1 @

/* pooled time series - cross section */
/* unbalanced sample */
/* IV approach */
/* SUR (two equations) */
/* newey-west (standard lag length) */

new; #lineson;
save path=d:\data\cu1\gauss;
output file=c:\prg\cu1\ctyiv1.out reset;
str=datestr(0);
tr=timestr(0);
cls;
"GAUSS                            time  ";; tr;; "  date (US) ";; str;
?;"input file: ctyiv1.prg";?;

@ chose parameter values @

equ=2; @ two equations @
white=0; @ 1: do white correction @
newe=1; @ 1: do newey-west correction @
it=1e2; @ max. number of iterations @
conve=1e-1; @ convergence criterion @
vnames="xx";

@ data files to be created @

dtset1="s:\\data\\cu1\\gauss\\cty\\isig";
dtset2="s:\\data\\cu1\\gauss\\cty\\isigx";
dtset3="s:\\data\\cu1\\gauss\\cty\\isigy";
dtset4="s:\\data\\cu1\\gauss\\cty\\sig";
dtset5="s:\\data\\cu1\\gauss\\cty\\isigz";
dtset6="s:\\data\\cu1\\gauss\\cty\\sigz";
/*
dtset1="isig";
dtset2="isigx";
dtset3="isigy";
dtset4="sig";
dtset5="isigz";
dtset6="sigz";
*/
@ read data @

open f1=d:\data\cu1\gauss\merge22_.fmt;
rw=rowsf(f1);
data=readr(f1,rw);
f1=close(f1);

open f1=d:\data\cu1\gauss\years_.fmt;
rw=rowsf(f1);
years=readr(f1,rw);
f1=close(f1);
years=years[.,3:cols(years)];

open f1=d:\data\cu1\gauss\states_.fmt;
rw=rowsf(f1);
states=readr(f1,rw);
f1=close(f1);
states=states[.,3:cols(states)];
crit=sumc(states);
states=delif(states',crit.==0)';
/*
open f1=d:\data\cu1\gauss\anndat_.fmt;
rw=rowsf(f1);
anndat=readr(f1,rw);
f1=close(f1);
anndat=anndat[.,3:cols(anndat)];
*/
@-----------------------------------------------------------@

@ definition of variables @

y1   =ln(data[.,9] ./(1-data[.,9])) ; @ participation rate @
y1lag=ln(data[.,12] ./(1-data[.,12])) ; @ lagged participation rate @
y2   =ln(data[.,36]./(1-data[.,36])); @ herf @
y2lag=ln(data[.,37]./(1-data[.,37])); @ lagged herf @
/*
y1   =(data[.,9]) ;   @ participation rate @
y1lag=(data[.,12]) ;  @ lagged participation rate @
y2   =ln(data[.,36]); @ herf @
y2lag=ln(data[.,37]); @ lagged herf @
*/
x1= y2lag                @ lagged herf @
    /* ~data[.,43]               @ real GSP per capita @ */
     ~(data[.,39]./data[.,38])    @ population density @
   ~states[.,2:cols(states)]  @ state dummies @
   ~years[.,2:cols(years)]    @ year dummies @
   ~ones(rows(data),1);

@ instruments @
z1= rankindx(y2lag,1) @ ranks of lagged herf @
    /* ~data[.,43]               @ real GSP per capita @ */
     ~(data[.,39]./data[.,38])    @ population density @
   ~states[.,2:cols(states)]  @ state dummies @
   ~years[.,2:cols(years)]    @ year dummies @
   ~ones(rows(data),1);

x2= y1lag             @ lagged weighted participation rate @
   /* ~data[.,43]  @ real GSP per capita @ */
    ~(data[.,39]./data[.,38])    @ population density @
   ~states[.,2:cols(states)]  @ state dummies @
   ~years[.,2:cols(years)]    @ year dummies @
   ~ones(rows(data),1);

@ instruments @
z2= rankindx(y1lag,1) @ ranks of lagged weighted participation rate @
  /*  ~data[.,43]  @ real GSP per capita @ */
    ~(data[.,39]./data[.,38])    @ population density @
   ~states[.,2:cols(states)]  @ state dummies @
   ~years[.,2:cols(years)]    @ year dummies @
   ~ones(rows(data),1);

clear data;

@-----------------------------------------------------------@

yearsn="1990"|"1991"|"1992"|"1993"|"1994"|"1995"|"1996";
clear years;

i=0; statesn="state";
do while i<cols(states)-2;
i=i+1;
statesn=statesn|"state";
endo;
if cols(states)-1 ne rows(statesn); "ERROR(2) -- wait"; wait; endif;
clear states;

names1="lnherlag"|"POPDENS"|statesn|yearsn|"const";
names2="partlag"|"POPDENS"|statesn|yearsn|"const";

@ assemble matrices @

y=y1|y2;
x= (x1~zeros(rows(x1),cols(x2)))
  |(zeros(rows(x2),cols(x1))~x2);
z= (z1~zeros(rows(z1),cols(z2)))
  |(zeros(rows(z2),cols(z1))~z2); @ instruments @
names=names1|names2;

/* ************************** core program ************************* */

@ estimate without contemporaneous correlation @

b=inv(z'x)*z'y;
b_ols=b; @ OLS @
res=y-x*b;

resmat=reshape(res,equ,rows(x)./equ); resmat=resmat';

sig=zeros(equ,equ); @ dummy-matrix; equ: number of equations @
i=0;
do while i<equ;
  i=i+1;
  j=0;
  do while j<equ;
    j=j+1;
    sig[i,j]=(resmat[.,i]'resmat[.,j])./rows(resmat);
  endo;
endo;

@ diagonal sigma @
  /*
  sig=diagrv(zeros(equ,equ),diag(sig)); @ no cont. correlation @
  */
bold=b;
/*
imat=eye(rows(x)./equ); @ identity matrix; on SUR, see Greene, 3rd., pp. 674-5 @
*/
   iti=0; break_=0; convec=-9;
   do while iti<it; @ iteration loop @

    if break_.==1; format /rd 2,0;
                   "convergence achieved after (";; iti-1;;") iteration(s)";
                   break;
    else;
    if iti.==it; format /rd 2,0;
                 "convergence not achieved after (";; iti-1;;") iteration(s)";
    endif;
    endif;

   iti=iti+1;
   /*
   b=inv(z'* (inv(sig).*.imat) *x)*z'* (inv(sig).*.imat) *y;
   bv=inv(z'x)*(z'(sig.*.imat)*z)*inv(x'z);
   */
   invsig=inv(sig);
   if rows(invsig) ne 2 or cols(invsig) ne 2;
     "error in invsig -- wait"; wait; endif;

   @ splitting up matrix operations @

      @ upper part of inv(sig).*.imat,sig.*.imat @
      i5=0; k=0;
      do while i5<rows(x)./equ;
      i5=i5+1; k=k+1;

      isig1=zeros(1,rows(x)./equ);
      isig2=isig1;
       sig1=zeros(1,rows(x)./equ);
       sig2= sig1;

      isig1[i5]=invsig[1,1];
      isig2[i5]=invsig[1,2];
       sig1[i5]=   sig[1,1];
       sig2[i5]=   sig[1,2];

      isigx=(isig1~isig2)*x;
      isigy=(isig1~isig2)*y;
      isigz=(isig1~isig2)*z;
       sigz=( sig1~ sig2)*z;

      if     i5==1; create f2=^dtset2 with ^vnames,cols(isigx),8;
                    create f3=^dtset3 with ^vnames,cols(isigy),8;
                    create f5=^dtset5 with ^vnames,cols(isigz),8;
                    create f6=^dtset6 with ^vnames,cols(sigz),8;
                    call writer(f2,isigx);
                    call writer(f3,isigy);
                    call writer(f5,isigz);
                    call writer(f6,sigz);
                    f2=close(f2);
                    f3=close(f3);
                    f5=close(f5);
                    f6=close(f6);
      elseif i5==2; open f2=^dtset2 for append;
                    open f3=^dtset3 for append;
                    open f5=^dtset5 for append;
                    open f6=^dtset6 for append;
                    call writer(f2,isigx);
                    call writer(f3,isigy);
                    call writer(f5,isigz);
                    call writer(f6,sigz);
      else;         call writer(f2,isigx);
                    call writer(f3,isigy);
                    call writer(f5,isigz);
                    call writer(f6,sigz);
      endif;

      if k.==5e2;
         format /re 12,3; locate 6,1;
         i5.*100./rows(x);; "%  ";; iti~maxc(convec)~conve;
         k=0;
      endif;

      endo; @ i5 @

      f2=close(f2);
      f3=close(f3);
      f5=close(f5);
      f6=close(f6);

      clear f2,f3,f5,f6,i5,k,isig,isigx,isigy,sigz;
      clear isig1,isig2,sig1,sig2;

      @ lower part of inv(sig).*.imat,sig.*.imat @
      i5=0; k=0;
      do while i5<rows(x)./equ;
      i5=i5+1; k=k+1;

      isig1=zeros(1,rows(x)./equ);
      isig2=isig1;
       sig1=zeros(1,rows(x)./equ);
       sig2= sig1;

      isig1[i5]=invsig[2,1];
      isig2[i5]=invsig[2,2];
       sig1[i5]=   sig[2,1];
       sig2[i5]=   sig[2,2];

      isigx=(isig1~isig2)*x;
      isigy=(isig1~isig2)*y;
      isigz=(isig1~isig2)*z;
       sigz=( sig1~ sig2)*z;

          if i5==1; open f2=^dtset2 for append;
                    open f3=^dtset3 for append;
                    open f5=^dtset5 for append;
                    open f6=^dtset6 for append;
                    call writer(f2,isigx);
                    call writer(f3,isigy);
                    call writer(f5,isigz);
                    call writer(f6,sigz);
      else;         call writer(f2,isigx);
                    call writer(f3,isigy);
                    call writer(f5,isigz);
                    call writer(f6,sigz);
      endif;

      if k.==5e2;
         format /re 12,3; locate 6,1;
         50+i5.*100./rows(x);; "%  ";; iti~maxc(convec)~conve;
         k=0;
      endif;

      endo; @ i5 @

      f2=close(f2);
      f3=close(f3);
      f5=close(f5);
      f6=close(f6);

      clear f2,f3,f5,f6,i5,k,isig,isigx,isigy,sigz;
      clear isig1,isig2,sig1,sig2;

@--------------------------------------------------------------------@

   open f2=^dtset2 for read;
   rw2=rowsf(f2);
   isigx=readr(f2,rw2);
   f2=close(f2);
   clear f2;

   open f3=^dtset3 for read;
   rw3=rowsf(f3);
   isigy=readr(f3,rw3);
   f3=close(f3);
   clear f3;

   open f6=^dtset6 for read;
   rw6=rowsf(f6);
   sigz=readr(f6,rw6);
   f6=close(f6);
   clear f6;

   b=inv(z'* isigx)*z'* isigy;
   bv=inv(z'x)*(z'sigz)*inv(x'z); @ no correction (White; Newey-West) @
   bv_no_wh=bv;

   if iti>1; convec=abs((b-bold)./bold);
             if maxc(convec)<conve; break_=1; endif;
   endif;
   bold=b;

   res=y-x*b;

   resmat=reshape(res,equ,rows(x)./equ); resmat=resmat';

   sig=zeros(equ,equ); @ dummy-matrix; equ: number of equations @
   i=0;
   do while i<equ;
     i=i+1;
     j=0;
     do while j<equ;
       j=j+1;
       sig[i,j]=(resmat[.,i]'resmat[.,j])./rows(resmat);
     endo;
   endo;

   @ diagonal sigma @
   /*
     sig=diagrv(zeros(equ,equ),diag(sig)); @ no cont. correlation @
   */

   endo; @ iti @

clear sigz,isigix,isigy;

/* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

@ Panel is STILL UNBALANCED @
@ Observations get be stacked like this:
                                          1993  firm1 (=county1)
                                          1992
                                          1991
                                          ....  ...
                                          1993  firm2 (=county2)
                                          1992
                                          1991
                                          ....  ...  @

/* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

@-------------------- White (1980) -----------------------@

@ matrix s0 of White; see Greene 3rd, pp. 442,505,674-5 @
@ balanced need not be balanced for that @

open f5=^dtset5 for read; @ isigz @
rw5=rowsf(f5);
zsur=readr(f5,rw5);
f5=close(f5);
clear f5;

@ format /re 10,5; sumc(sumc(zsur)); @
/*
zsur=(inv(sig).*.eye(rows(x)./equ))*z;
@ format /re 10,5; sumc(sumc(zsur)); @
*/
i6=0;
do while i6<rows(zsur); @ go over obs @
i6=i6+1;
if i6==1; s0=   (res[i6].^2).*(zsur[i6,.]'*zsur[i6,.]);
else;     s0=s0+(res[i6].^2).*(zsur[i6,.]'*zsur[i6,.]);
endif;
endo;
s0=s0./rows(x); @ divide by number of obs; Greene, 3rd., p. 505 @

@ format /re 10,6; sumc(sumc(s0)); @

@-------------------- Newey-West (1987) -----------------------@

@ Newey-West; see Greene, 3rd., pp. 506,674-5 @
@ panel has to be balanced for that @
@ blow up matrices res and zsur to balanced panel @

res1 = res[1:rows(x1)];
res2 = res[rows(x1)+1:rows(res)];
zsur1=zsur[1:rows(x1),.];
zsur2=zsur[rows(x1)+1:rows(zsur),.];
/*
clear zsur; @ keep res @
*/
if rows(res1) ne rows(x1) or rows(res2) ne rows(x2);
"error in res1 and/or res2 -- wait"; wait; endif;

if rows(zsur1) ne rows(x1) or rows(zsur2) ne rows(x2);
"error in zsur1 and/or zsur2 -- wait"; wait; endif;

open f1=d:\data\cu1\gauss\yp.fmt;
rw=rowsf(f1);
yp=readr(f1,rw); @ years present @
f1=close(f1);

open f1=d:\data\cu1\gauss\prall.fmt;
rw=rowsf(f1);
prall=readr(f1,rw); @ firms present @
f1=close(f1);

open f1=d:\data\cu1\gauss\pryrs.fmt;
rw=rowsf(f1);
pryrs=readr(f1,rw); @ firms present in specific years @
f1=close(f1);

open f1=d:\data\cu1\gauss\npyrs.fmt;
rw=rowsf(f1);
npyrs=readr(f1,rw); @ firms not present in specific years @
f1=close(f1);

@ if in at least one year all firms are not present, there will be a zero
  column, which has to be removed @

ex=(sumc(npyrs).==0);
/* ex; wait; */
if sumc(ex)>0; npyrs=(delif(npyrs',ex))'; endif;

@ generate years @

@ for those not present @
ymatnp=sumc(((npyrs./=0).*yp')');
/* format /rd 5,0; ymatnp; wait; */

@ for those present @
ymatpr=sumc(((pryrs./=0).*yp')');
/* format /rd 5,0; ymatpr; wait; */

@ blow it up @

res1_= (ymatpr~sumc(pryrs')~res1)
      |(ymatnp~sumc(npyrs')~zeros(rows(sumc(npyrs')),cols(res1)));
res2_= (ymatpr~sumc(pryrs')~res2)
      |(ymatnp~sumc(npyrs')~zeros(rows(sumc(npyrs')),cols(res2)));
zsur1_= (ymatpr~sumc(pryrs')~zsur1)
      |(ymatnp~sumc(npyrs')~zeros(rows(sumc(npyrs')),cols(zsur1)));
zsur2_= (ymatpr~sumc(pryrs')~zsur2)
      |(ymatnp~sumc(npyrs')~zeros(rows(sumc(npyrs')),cols(zsur2)));
clear res1,res2,zsur1,zsur2;

@ sort it @

res1_[.,1]=-res1_[.,1];
res1_=sortmc(res1_,2|1);
res1_[.,1]=abs(res1_[.,1]);
res2_[.,1]=-res2_[.,1];
res2_=sortmc(res2_,2|1);
res2_[.,1]=abs(res2_[.,1]);
@ format /rd 8,0; res1_~res2_; wait; @

zsur1_[.,1]=-zsur1_[.,1];
zsur1_=sortmc(zsur1_,2|1);
zsur1_[.,1]=abs(zsur1_[.,1]);
zsur2_[.,1]=-zsur2_[.,1];
zsur2_=sortmc(zsur2_,2|1);
zsur2_[.,1]=abs(zsur2_[.,1]);
@ format /rd 8,0; zsur1_~zsur2_; wait; @

@ stack years @
res_ = res1_[.,cols(res1_)]   | res2_[.,cols(res2_)];
zsur_=zsur1_[.,3:cols(zsur1_)]|zsur2_[.,3:cols(zsur2_)];
/*
clear res1_,res2_,zsur1_,zsur2_;
*/
@ end of blowing up matrices to balanced panel @

@ the following is complicated by the presence of two seemingly unrelated
  equations @

@ use standard lag length @

l=floor(4.*(rows(yp)./1e2).^(2./9));

@ correct the manually set lag length if incorrect @

if l>rows(yp); l=rows(yp)-1;
"WARNING: lag length was corrected -- wait"; wait; endif;

yrs=rows(yp);    @ number of years @
dmu=rows(prall); @ number of firms @

@ generate vector exvec: extracts the observations of the first county @
exvec1=seqa(1,1,yrs);

rj=zeros(l,2); @ for Ljung-Box; Greene, 3rd., p. 595 @

i1=0;
do while i1<dmu.*equ; @ # of counties times # of equations @
i1=i1+1;

exvec=exvec1+(i1-1).*yrs; @ choose a single county in a single equation @
/* exvec'; wait; */
res__ = res_[exvec];
zsur__=zsur_[exvec,.];

i2=0; @ Greene: j @
do while i2<l;
i2=i2+1;

rj[i2,2]=yrs-i2;
w=1-i2./(l+1);

i3=i2; @ Greene: t @
do while i3<yrs;
i3=i3+1;

@ fuer Ljung-Box; Greene, 3rd., pp. 595 @
rj[i2,1]=rj[i2,1]+(res__[i3].*res__[i3-i2]);

mat   =  w.*res__[i3].*res__[i3-i2]
       .*(zsur__[i3,.]'*zsur__[i3-i2,.]+zsur__[i3-i2.,]'*zsur__[i3,.]);
/* i2;; i3; wait; */

if i1.==1 and i2.==1 and i3.==i2+1; s_star=mat; else; s_star=s_star+mat; endif;

endo; @ i3 @
endo; @ i2 @
endo; @ i1 @
s_star=s_star./rows(x); @ divide by number of obs @

@ calculate Ljung-Box @
@ do it for each equation separately @

rj1=rj[1:rows(rj)./2,.];
rj2=rj[1+rows(rj)./2,.];
res1=res[1:rows(res)./2,.];
res2=res[1+rows(res)./2:rows(res),.];
rj1[.,1]=rj1[.,1]./sumc(res1.^2); @ rj, see Greene, p. 427, first formula @
rj2[.,1]=rj2[.,1]./sumc(res2.^2);
rj1=(rj1[.,1].^2)./rj1[.,2];      @ squared and divided by T-j @
rj2=(rj2[.,1].^2)./rj2[.,2];
qprime1=sumc(rj1).*(yrs).*(yrs+2);
qprime2=sumc(rj2).*(yrs).*(yrs+2);
p1=cdfchic(qprime1,l);
p2=cdfchic(qprime2,l);
format /rd 5,0; "Ljung-Box-statistics: (";;l;;")";;
format /re 12,3; qprime1;; format /rd 8,4; ",  rhs-probability:" p1;;
if p1 le 0.01; "***"; elseif p1 gt 0.01 and p1 le 0.05; "**";
elseif p1 gt 0.05 and p1 le 0.1; "*"; else; " "; endif;
format /rd 5,0; "Ljung-Box-statistic: (";;l;;")";;
format /re 12,3; qprime2;; format /rd 8,4; ",  rhs-probability:" p2;;
if p2 le 0.01; "***"; elseif p2 gt 0.01 and p2 le 0.05; "**";
elseif p2 gt 0.05 and p2 le 0.1; "*"; else; " "; endif;
/*
if p1<0.1 or p2<0.1; newe=1; white=0; else; newe=0; endif;
*/
if white .==1; s_ast=s0;        endif; @ Greene, 3rd., p. 505 @
if newe.==1; s_ast=s0+s_star; endif; @ Greene, 3rd., p. 506 @

clear s0,s_star;

if white.==1 or newe.==1;
   /*
   imat=eye(rows(x)./equ);
   bv=rows(x)
        .*inv(z'* (inv(sig).*.imat) *x) *s_ast *inv(x'* (inv(sig).*.imat) *z);
   clear imat;
   */
   open f2=^dtset2 for read;
   rw2=rowsf(f2);
   isigx=readr(f2,rw2);
   f2=close(f2);
   clear f2;

   open f5=^dtset5 for read;
   rw5=rowsf(f5);
   isigz=readr(f5,rw5);
   f5=close(f5);
   clear f5;

   bv=rows(z)
        .*inv(z'isigx)*s_ast*inv(x'isigz); @ White or Newey-West @

endif;

@-------------------- ENDE newey-west (1987) -----------------------@

@ R2=squared correlation coefficient - for each equation separately @

i=0; r2=seqa(1,1,equ)~zeros(equ,1);
do while i<equ;
i=i+1;
ub=(i-1).*rows(res)./2+1;
lb=i.*rows(res)./2;
y_=y[ub:lb];
y_=y[ub:lb];
res_=res[ub:lb];
res_=res[ub:lb];
cx=(corrx(y_~(y_+res_))).^2; @ Pseudo R2 @
r2[i,2]=cx[2,1];
endo;

@ System R2,R2adj. @

r2sys=1-(res'res)./(y'y-rows(y).*((meanc(y)).^2));
r2sysadj=1-(1-r2sys) .* (rows(y)-1) ./ (rows(y)-rows(b));

@ Ausdrucken @

format /rd 6,0; "Number of observations per equation: "  rows(y)./rows(sig);
if newe==1; "lag length L: " l; endif;
format /rd 12,6; "system R2:" r2sys;
"system R2adj.:" r2sysadj;

"# of equ. and Pseudo R2 (squared corr. coeff. between y and y_hat)";
omat=r2;
mask=ones(1,2);
let fmt[2,3] = "*.*lf"  6  0
               "*.*lf"  12  6;
call printfm(omat,mask,fmt);

"# of equ. and Pseudo R2 adj. (squared corr. coeff. between y and y_hat, adj.)";
omat=r2sysadj;
mask=ones(1,2);
let fmt[2,3] = "*.*lf"  6  0
               "*.*lf"  12  6;
call printfm(omat,mask,fmt);

?;"  variable -- beta -- t-value -- t-value corr. -- one-tail prob. -- sign.";?;
tvec=b./sqrt(diag(bv));
tvecnc=b./sqrt(diag(bv_no_wh)); @ neither White nor Newey-West @
p1=cdfnc(abs(tvec));

cvi=0;
do while cvi<rows(tvec);
cvi=cvi+1;
if cvi==1; let cv =" "; else; cv=cv|" "; endif;
endo;

cvi=0;
do while cvi<rows(tvec);
cvi=cvi+1;
if     p1[cvi] le (0.01)./2;                          cv[cvi]="***";
elseif p1[cvi] gt (0.01)./2 and p1[cvi] le (0.05)./2; cv[cvi]="**";
elseif p1[cvi] gt (0.05)./2 and p1[cvi] le (0.1)./2;  cv[cvi]="*";
endif;
endo;

save b,bv,sig,res;
omat=  seqa(1,1,rows(b))
     ~ names
     ~ b
     ~ tvecnc
     ~ tvec
     ~ cdfnc(abs(tvec))
     ~ cv;

mask=1~0~ones(1,4)~0;
let fmt[7,3] = "*.*lf"  6  0
               "*.*s"  12  8
               "*.*le" 14  3
               "*.*lf" 10  3
               "*.*lf" 10  3
               "*.*lf" 10  4
               "*.*s"  12  8;
call printfm(omat,mask,fmt);

if white==1; ?;"Wald- and F-tests are based on White(1980)"; endif;
if newe==1; ?;"Wald- and F-tests are based on Newey-West(1987)"; endif;

@ Wald-tests and F-tests @

?;"Wald- and F-test on significance of group of nonconstant regressors";
@ see Greene, 2nd ed., pages 188-189, 391, 392, 488, 491 @
@ we test on those that we set equal to one @
r=eye(rows(b));
r[rows(r)./2,rows(r)./2]=0;
j=sumc(sumc(r)); @ number of restrictions @
gosub flag3;

?;"Wald- and F-tests on significance of group of state dummies";
@ see Greene, 2nd ed., pages 188-189, 391, 392, 488, 491 @
@ we test on those that we set equal to one @
r=eye(rows(b));
rd=zeros(rows(b),1);
rd[3:52]=ones(52-3+1,1);
r=diagrv(r,rd);
j=sumc(sumc(r)); @ number of restrictions @
gosub flag3;

?;"Wald- and F-tests on significance of group of time dummies";
@ see Greene, 2nd ed., pages 188-189, 391, 392, 488, 491 @
@ we test on those that we set equal to one @
r=eye(rows(b));
rd=zeros(rows(b),1);
rd[53:59]=ones(59-53+1,1);
r=diagrv(r,rd);
j=sumc(sumc(r)); @ number of restrictions @
gosub flag3;

?;"Wald- and F-test on significance of group of nonconstant regressors";
@ see Greene, 2nd ed., pages 188-189, 391, 392, 488, 491 @
@ we test on those that we set equal to one @
r=eye(rows(b));
r[rows(r),rows(r)]=0;
j=sumc(sumc(r)); @ number of restrictions @
gosub flag3;

?;"Wald- and F-tests on significance of group of state dummies";
@ see Greene, 2nd ed., pages 188-189, 391, 392, 488, 491 @
@ we test on those that we set equal to one @
r=eye(rows(b));
rd=zeros(rows(b),1);
rd[63:112]=ones(112-63+1,1);
r=diagrv(r,rd);
j=sumc(sumc(r)); @ number of restrictions @
gosub flag3;

?;"Wald- and F-tests on significance of group of time dummies";
@ see Greene, 2nd ed., pages 188-189, 391, 392, 488, 491 @
@ we test on those that we set equal to one @
r=eye(rows(b));
rd=zeros(rows(b),1);
rd[113:119]=ones(119-113+1,1);
r=diagrv(r,rd);
j=sumc(sumc(r)); @ number of restrictions @
gosub flag3;

@ Test on b11 x b21 @

c_=zeros(1,rows(b));
c_[1]=b[61];
c_[61]=b[1];
c_test=c_*bv*c_';
?;"Test - Delta method:";
cval=(b[1].*b[61]-1)./sqrt(c_test);
format /re 15,7; "   test value:" cval;
format /rd 10,3; "   rhs-probability:" cdfnc(abs(cval));

flag4:?;

"Bera-Jarque test on normality:";

i=0; bj=seqa(1,1,equ)~zeros(equ,2);
do while i<equ;
i=i+1;
ub=(i-1).*rows(res)./2+1;
lb=i.*rows(res)./2;
res_=res[ub:lb];
res_=res[ub:lb];
sig_=sqrt(sig[i,i]);
mu3=meanc(res_.^3); mu4=meanc(res_.^4);
lambd=  ((mu3.^2)./(6.*sig_.^6)
       +((mu4-3.*sig_.^4).^2)./(24.*sig_.^8)).*rows(res_);
p=cdfchic(lambd,2);
bj[i,2 3]=lambd~p;
endo;

"# of equ., BJ-statistic and rhs-probability";
omat=bj;
mask=ones(1,3);
let fmt[3,3] = "*.*lf"  6  0
               "*.*le"  12 4
               "*.*lf"  8  4;
call printfm(omat,mask,fmt);

end;

flag3:
@ see Greene, page 392 @
i4=0; ex=zeros(rows(r),1);
do while i4<rows(r);
i4=i4+1;
if r[i4,.]==zeros(1,cols(r)); ex[i4]=1; endif;
endo;
r=delif(r,ex);
f=(1./j).*(r*b)'inv(r*bv*r')*(r*b); @ F-test @
w=j.*f; @ Wald-test @

p1=cdfchic(w,j);
format /rd 5,0; "Wald-statistic: (";;j;;")  ";;
format /re 15,7; w;; format /rd 5,3; ",  rhs-probability:  " p1;;
if p1 le 0.01; "***"; elseif p1 gt 0.01 and p1 le 0.05; "**";
elseif p1 gt 0.05 and p1 le 0.1; "*"; else; " "; endif;

v1=j; v2=rows(x)-rows(b);
p1=cdffc(f,v1,v2);
format /rd 5,0; "F-statistic: (";;v1;;";";;v2;;")  ";;
format /re 15,7; f;; format /rd 5,3; ",  rhs-probability:  " p1;;
if p1 le 0.01; "***"; elseif p1 gt 0.01 and p1 le 0.05; "**";
elseif p1 gt 0.05 and p1 le 0.1; "*"; else; " "; endif;

return;

