@ sets up dataset for unbalanced panel analysis with ctypool1.prg @
@ run it after ctyagg1.prg and before ctypool1.prg @

new; #lineson;
/* disable; @ disable: ermoeglicht Rechnen mit missing values @ */
save path=d:\data\cu1\gauss;

output file=c:\prg\cu1\ctyset1.out reset;

str=datestr(0);
"GAUSS                                             date (US)";; str;
?;
"input file: ctyset1.prg";?;
@ screen off; output off; @

/* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

@ Lesen der Daten @

@ Panel is unbalanced @
@ Observations get be stacked like this:
                                          1993  firm1 (=county1)
                                          1992
                                          1991
                                          ....  ...
                                          1993  firm2 (=county2)
                                          1992
                                          1991
                                          ....  ...  @

open f1=d:\data\cu1\gauss\years_.fmt;
rw=rowsf(f1);
year=readr(f1,rw);
f1=close(f1);

pena=year[.,1 2]; @ take the two leading columns: year~charter# @
year=year[.,3:cols(year)]; @ get rid of the two leading columns @

/* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

@ firms that are present @

@ presence in panel @
prall=unique(pena[.,2],1);
format /rd 4,0;
save prall;
/* prall'; wait; */

@ presence in individual years @
pryrs=year.*pena[.,2];
/* pryrs; wait; */
save pryrs;

@ not present in individual years @
i1=0;
do while i1<cols(year);
i1=i1+1;
np=setdif(prall,pryrs[.,i1],1);
if sumc(np)<1; np=0; endif; @ all firms present @
/* np'; wait; */
if i1==1; npyrs=np;
else;     npyrs= (npyrs~zeros(rows(npyrs),1))
                |(zeros(rows(np),cols(npyrs))~np);
endif;
endo;
/* npyrs; wait; */
save npyrs; clear np;

/* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

@ Where are the firms located that are not present in the
  individual years? @

panel=pena[.,1 2]~ones(rows(pena),1); @ year~firm number~1 @
                                      @ "1" means "present" @
/* panel; wait; */
yp=unique(pena[.,1],1); @ years present @
/* yp; */
if rows(yp) ne cols(year); "ERROR(1) -- wait"; wait; endif;
mat=sumc(((npyrs./=0).*yp')')~sumc(npyrs');
/* mat; wait; */
mat=mat~zeros(rows(mat),1); @ "0" stands for "not present" @
panel=panel|mat; clear mat; @ complete and balanced panel @
/* panel; wait; */
panel[.,1]=-panel[.,1];
panel=sortmc(panel,1|2);
panel=abs(panel);
/* panel; wait; */

@ spot the obs that are not really there @
panelpr=(panel[.,3].==0);
panelnp=(panel[.,3].==1);

save panelpr, panelnp, yp;
clear panelpr, panelnp, yp, mat, panel;

end;
