@ Programm ctystat1 @

/* based on ctysiv1.prg */
/* distribution of credit unions by tom code and year */

new; #lineson;
save path=d:\data\cu1\gauss;
output file=c:\prg\cu1\ctystat1.out reset;
str=datestr(0);
tr=timestr(0);
cls;
"GAUSS                            time  ";; tr;; "  date (US) ";; str;
?;"input file: ctystat1.prg";?;

@ read data @

open f1=d:\data\cu1\gauss\merge22_.fmt;
rw=rowsf(f1);
data=readr(f1,rw);
f1=close(f1);

open f1=d:\data\cu1\gauss\years_.fmt;
rw=rowsf(f1);
years=readr(f1,rw);
f1=close(f1);
years=years[.,3:cols(years)];

open f1=d:\data\cu1\gauss\states_.fmt;
rw=rowsf(f1);
states=readr(f1,rw);
f1=close(f1);
states=states[.,3:cols(states)];
crit=sumc(states);
states=delif(states',crit.==0)';
/*
open f1=d:\data\cu1\gauss\anndat_.fmt;
rw=rowsf(f1);
anndat=readr(f1,rw);
f1=close(f1);
anndat=anndat[.,3:cols(anndat)];
*/
@-----------------------------------------------------------@

@ definition of variables @

y1   =ln(data[.,9] ./(1-data[.,9])) ; @ participation rate @
y2   =ln(data[.,36]./(1-data[.,36])); @ herf @

@-----------------------------------------------------------@

yearsn="1990"|"1991"|"1992"|"1993"|"1994"|"1995"|"1996";
/*
@ herf @
x=selif(data[.,36],years[.,8].==1); @ 1989,...1996 @
gosub flag1;
*/
@ participation rate @
x=selif(data[.,9],years[.,8].==1); @ 1989,...1996 @
gosub flag1;

end;

flag1:
format /rd 10,2; minc(x);; median(x);; meanc(x);; maxc(x);; stdc(x);
format /rd 10,0; rows(x);
return;

end;
