@ Programm cu1.prg @

/* this file reads cutom;
   it eliminates cus with missing tom codes (they may have been excluded
   by Rob Webb already);
   it eliminates cus with charter numbers greater than 60,000;
   it runs checks;
   it writes a files named cutom1;
   it reads in cutom1 and sorts it; writes out cutom2 */

new; #lineson;
save path=d:\data\cu1\gauss;
output file=c:\prg\cu1\cu1.out reset;
screen on; @ output off; @

dstr=datestr(0); tstr=timestr(0);
cls;
"GAUSS                                   date (US)" dstr;; "  ";; tstr;
?;"input file: cu1.prg";?;

vnames="xx";
dtset3="d:\\data\\cu1\\gauss\\cutom1";

@ Lesen der Daten @

dos pkunzip -3 -) d:\data\cu1\gauss\cutom.zip c:\prg\cu1;
dtset1="cutom";
open f1=^dtset1 for read;
rw1=rowsf(f1);

let sv = 1 1 25 80 0 7; scroll sv; locate 5,1;
"...currently working on cutom...";

step=1e3;
i5=0; i6=0; @ i5,i6: Zaehler; nicht aendern @
do until eof(f1);
i6=i6+1;

if i6==0 or i6==5; i6=0;
format /rd 6,0; locate 6,1;
1e2.*minc((i5.*step)|rw1)./rw1;; "percent done";
endif;

dat=readr(f1,step);

exvec=  (dat[.,3].>-1)     @ tom code; "0" is a possible tom code @
      .*(dat[.,2].<60000); @ charter number @

if sumc(exvec).>=1; i5=i5+1;

   dat=selif(dat,exvec);

   if     i5==1; create f3=^dtset3 with ^vnames,cols(dat),8;
                 call writer(f3,dat);
                 f3=close(f3);
                 min_=minc(dat); max_=maxc(dat);
   elseif i5==2; open f3=^dtset3 for append; @ file bleibt offen @
                 call writer(f3,dat);
                 min_=minc(min_'|(minc(dat))');
                 max_=maxc(max_'|(maxc(dat))');
   else;         call writer(f3,dat);
                 min_=minc(min_'|(minc(dat))');
                 max_=maxc(max_'|(maxc(dat))');
   endif;
endif;

endo; @ read until eof @

f1=close(f1);
f3=close(f3);
clear f1,f3;
clear exvec, dat;

format /rd 12,0;
open f1=^dtset1 for read;
rw1=rowsf(f1);
f1=close(f1);
"orig number of obs:" rw1;

open f3=^dtset3 for read;
rw3=rowsf(f3);
f3=close(f3);
"number of obs left:" rw3;

"minimum vector:" min_;
"maximum vector:" max_;

dos del cutom.d?t;
dos pkzip -3 -)  d:\data\cu1\gauss\cutom1.zip
           d:\data\cu1\gauss\cutom1.d?t;
dos del    d:\data\cu1\gauss\cutom1.d?t;

@-----------------------------------------------------------------------@

@ restore old tom codes; (letters can be ignored) @
@ if extra digit is a letter, simply chop it off @
@ if extra digit is a number, it is an old tom code; transform it into
  a new one @
@ dataset gets sorted by year~charter# @

@ Lesen der Daten @

dtset3="d:\\data\\cu1\\gauss\\cutom2";

dos pkunzip -3 -) d:\data\cu1\gauss\cutom1.zip c:\prg\cu1;
dtset1="cutom1";
open f1=^dtset1 for read;
rw1=rowsf(f1);
dat=readr(f1,rw1);
f1=close(f1);
clear f1;

"tom codes as reported in column 3:";
unique(dat[.,3],1)';

crit=(dat[.,4].$=="0"); @ extra digit is a zero @
y=indexcat(crit,1);
if sumc(y)>0; dat[y,3]=dat[y,3].*10; endif;
y_=y; @ collect info on location @

crit=(dat[.,4].$=="1"); @ extra digit is a one @
y=indexcat(crit,1);
if sumc(y)>0; dat[y,3]=(dat[y,3].*10)+1; endif;
y_=y_|y;

crit=(dat[.,4].$=="2"); @ extra digit is a two @
y=indexcat(crit,1);
if sumc(y)>0; dat[y,3]=(dat[y,3].*10)+2; endif;
y_=y_|y;

crit=(dat[.,4].$=="3"); @ extra digit is a three @
y=indexcat(crit,1);
if sumc(y)>0; dat[y,3]=(dat[y,3].*10)+3; endif;
y_=y_|y;

crit=(dat[.,4].$=="4"); @ extra digit is a four @
y=indexcat(crit,1);
if sumc(y)>0; dat[y,3]=(dat[y,3].*10)+4; endif;
y_=y_|y;

crit=(dat[.,4].$=="5"); @ extra digit is a five @
y=indexcat(crit,1);
if sumc(y)>0; dat[y,3]=(dat[y,3].*10)+5; endif;
y_=y_|y;

crit=(dat[.,4].$=="6"); @ extra digit is a six @
y=indexcat(crit,1);
if sumc(y)>0; dat[y,3]=(dat[y,3].*10)+6; endif;
y_=y_|y;

crit=(dat[.,4].$=="7"); @ extra digit is a seven @
y=indexcat(crit,1);
if sumc(y)>0; dat[y,3]=(dat[y,3].*10)+7; endif;
y_=y_|y;

crit=(dat[.,4].$=="8"); @ extra digit is an eight @
y=indexcat(crit,1);
if sumc(y)>0; dat[y,3]=(dat[y,3].*10)+8; endif;
y_=y_|y;

crit=(dat[.,4].$=="9"); @ extra digit is a nine @
y=indexcat(crit,1);
if sumc(y)>0; dat[y,3]=(dat[y,3].*10)+9; endif;
y_=y_|y;

"showing three-digit tom codes:";
crit=unique(dat[y_,3],1); crit';

@ policy:  if the credit union was around in 1996 or later, the tom codes
           for all observed years are the new ones; otherwise, the three
           digit tom codes are the old ones; @

@ find all observations of 1996 or later @
crit1=(dat[y_,1].>=1996); @ obs. with updated three-digit tom codes @
crit2=indexcat(crit1,1); @ location of these observations in dat-matrix @
crit3=unique(dat[crit2,2],1); @ get the charter number of these credit unions @
"charter numbers of updated three-digit credit unions:";
crit3';
"tom codes of updated three-digit credit unions (check whether they can";
"really be new ones -- wait";
unique(dat[crit2,3],1); wait; @ get the tom codes @
crit4=sumc((dat[.,2].==crit3')'); @ get all obs with these charter numbers @
crit4=indexcat(crit4,1); @ get the locations of these obs @
crit5=sumc((y_.==crit4')');  @ matching locations @
y_=delif(y_,crit5);
@ y_'; "wait"; wait; @

"showing old three-digit tom codes:";
unique(dat[y_,3],1)';

i=0;
do while i<rows(y_); @ "-9" means "not convertable" @
i=i+1;
if     dat[y_[i],3].==  0; dat[y_[i],3]=0;
elseif dat[y_[i],3].==  9; dat[y_[i],3]=-9;
elseif dat[y_[i],3].== 10; dat[y_[i],3]=-9;
elseif dat[y_[i],3].== 20; dat[y_[i],3]=2;
elseif dat[y_[i],3].== 30; dat[y_[i],3]=1;
elseif dat[y_[i],3].== 40; dat[y_[i],3]=-9;
elseif dat[y_[i],3].== 50; dat[y_[i],3]=4;
elseif dat[y_[i],3].== 60; dat[y_[i],3]=60;
elseif dat[y_[i],3].== 99; dat[y_[i],3]=3;
elseif dat[y_[i],3].==101; dat[y_[i],3]=-9;
elseif dat[y_[i],3].==102; dat[y_[i],3]=15;
elseif dat[y_[i],3].==201; dat[y_[i],3]=15;
elseif dat[y_[i],3].==202; dat[y_[i],3]=15;
elseif dat[y_[i],3].==203; dat[y_[i],3]=15;
elseif dat[y_[i],3].==204; dat[y_[i],3]=15;
elseif dat[y_[i],3].==205; dat[y_[i],3]=15;
elseif dat[y_[i],3].==206; dat[y_[i],3]=15;
elseif dat[y_[i],3].==207; dat[y_[i],3]=15;
elseif dat[y_[i],3].==208; dat[y_[i],3]=10;
elseif dat[y_[i],3].==209; dat[y_[i],3]=11;
elseif dat[y_[i],3].==210; dat[y_[i],3]=10;

elseif dat[y_[i],3].==211; dat[y_[i],3]=15;
elseif dat[y_[i],3].==212; dat[y_[i],3]=15;
elseif dat[y_[i],3].==213; dat[y_[i],3]=12;
elseif dat[y_[i],3].==214; dat[y_[i],3]=12;
elseif dat[y_[i],3].==215; dat[y_[i],3]=13;
elseif dat[y_[i],3].==216; dat[y_[i],3]=13;
elseif dat[y_[i],3].==217; dat[y_[i],3]=14;
elseif dat[y_[i],3].==218; dat[y_[i],3]=14;
elseif dat[y_[i],3].==219; dat[y_[i],3]=14;
elseif dat[y_[i],3].==220; dat[y_[i],3]=14;
elseif dat[y_[i],3].==222; dat[y_[i],3]=15;
elseif dat[y_[i],3].==229; dat[y_[i],3]=15;
elseif dat[y_[i],3].==301; dat[y_[i],3]=22;
elseif dat[y_[i],3].==302; dat[y_[i],3]=22;
elseif dat[y_[i],3].==303; dat[y_[i],3]=22;
elseif dat[y_[i],3].==304; dat[y_[i],3]=22;
elseif dat[y_[i],3].==305; dat[y_[i],3]=22;
elseif dat[y_[i],3].==306; dat[y_[i],3]=22;
elseif dat[y_[i],3].==310; dat[y_[i],3]=23;
elseif dat[y_[i],3].==311; dat[y_[i],3]=23;

elseif dat[y_[i],3].==401; dat[y_[i],3]=20;
elseif dat[y_[i],3].==402; dat[y_[i],3]=20;
elseif dat[y_[i],3].==500; dat[y_[i],3]=20;
elseif dat[y_[i],3].==601; dat[y_[i],3]=-9;
elseif dat[y_[i],3].==602; dat[y_[i],3]=21;
elseif dat[y_[i],3].==603; dat[y_[i],3]=-9;
elseif dat[y_[i],3].==604; dat[y_[i],3]=-9;
elseif dat[y_[i],3].==701; dat[y_[i],3]=6;
elseif dat[y_[i],3].==702; dat[y_[i],3]=5;
elseif dat[y_[i],3].==703; dat[y_[i],3]=6;
elseif dat[y_[i],3].==704; dat[y_[i],3]=6;
elseif dat[y_[i],3].==706; dat[y_[i],3]=4;
elseif dat[y_[i],3].==707; dat[y_[i],3]=4;
elseif dat[y_[i],3].==801; dat[y_[i],3]=-9;
elseif dat[y_[i],3].==802; dat[y_[i],3]=-9;
elseif dat[y_[i],3].==803; dat[y_[i],3]=-9;
elseif dat[y_[i],3].==902; dat[y_[i],3]=70;
elseif dat[y_[i],3].==909; dat[y_[i],3]=0;
elseif dat[y_[i],3].==952; dat[y_[i],3]=70;
elseif dat[y_[i],3].==959; dat[y_[i],3]=0;

endif;
endo;

"tom codes showing after conversion:";
unique(dat[.,3],1)';

@ remove all tom codes which are either equal to -9 or unkown @

format /rd 6,0;
"nobs before eliminating missing of unkown tom codes: "  rows(dat);
crit=-9~8; @ -9: missing; "8": the only observed unknown tom code @
ex=sumc((dat[.,3].==crit)');
if sumc(ex)>0; dat=delif(dat,ex); endif;
format /rd 6,0;
"nobs after eliminating missing of unkown tom codes: "  rows(dat);
    /*
dat=(trimr(dat',0,1))';  @ drop last column @
v=1|2; dat=sortmc(dat,v);
   */
create f3=^dtset3 with ^vnames,cols(dat),8;
call writer(f3,dat);
f3=close(f3);
clear f3, dat;

dos del cutom1.d?t;
dos pkzip -3 -)  d:\data\cu1\gauss\cutom2.zip
           d:\data\cu1\gauss\cutom2.d?t;
dos del    d:\data\cu1\gauss\cutom2.d?t;

@-----------------------------------------------------------------------@

end;
