@ Programm cu15.prg @

/* this file is similar to cu10.prg - cu14.prg, except that is does not
   match county-specific but state-specific data;
   it adds state-specific income/product data to the merge17-file;
   there are eight columns to be added; there are no missing observations;
   it writes a file named merge18;
   deletes 'no-matches'; writes merge19;
   sorts for nwpool1.prg (for further sorting needed); writes merge20 */
/* program does not have to be adjusted if new dataset was pulled;
   simply re-running will do the job */

new; #lineson;
save path=d:\data\cu1\gauss;
output file=c:\prg\cu1\cu15.out reset;
screen on; @ output off; @

dstr=datestr(0); tstr=timestr(0);
cls;
"GAUSS                                   date (US)" dstr;; "  ";; tstr;
?;"input file: cu15.prg";?;

vnames="xx";
dtset3="d:\\data\\cu1\\gauss\\merge18";

@ Lesen der Daten und sortieren @

dtset5="temp";
dtset1="merge17";
dos pkunzip -3 -) d:\data\cu1\gauss\merge17.zip c:\prg\cu1;

open f1=^dtset1 for read;
rw1=rowsf(f1);
dat=readr(f1,rw1);
f1=close(f1);
clear f1;

v=1|6; dat=sortmc(dat,v);  @ year and state (not county) @

create f5=^dtset5 with ^vnames,cols(dat),8;
call writer(f5,dat);
f5=close(f5);
clear f5, dat;

@---------@

dtset2="d:\\data\\cu1\\gauss\\st_inc";
open f2=^dtset2 for read;
rw2=rowsf(f2);
st_inc=readr(f2,rw2); @ state income/product @
f2=close(f2);

open f5=^dtset5 for read;
rw5=rowsf(f5);

let sv = 1 1 25 80 0 7; scroll sv; locate 5,1;
"...currently working on merge18...";

step=5e2;
i5=0; i6=0; @ i5,i6: Zaehler; nicht aendern @
do until eof(f5);
i5=i5+1; i6=i6+1;

if i6==0 or i6==1; i6=0;
format /rd 6,0; locate 6,1;
1e2.*minc((i5.*step)|rw5)./rw5;; "percent done";
endif;

dat=readr(f5,step);

dat=dat~(-9.*ones(rows(dat),8)); @ append eight dummy columns @

i7=0; format /rd 8,0;
do while i7<rows(dat);
i7=i7+1;

@ select location to start of loop @
crit1=dat[i7,1]; loca1=indexcat(st_inc[.,1],crit1); @ year @
/* crit1; "loca1 - wait"; wait; */
if missrv(crit1,-9).==-9; goto flag1; endif;
crit2=dat[i7,6]; loca2=indexcat(st_inc[.,2],crit2); @ state @
/* crit2; "loca2 - wait" wait; */
if missrv(crit2,-9).==-9; goto flag1; endif;

i9=0;
do while i9<rows(loca2);
i9=i9+1;
loca3=missrv(indexcat(loca1,loca2[i9]),-9); @ scalar @
if loca3 ne -9; i8=loca1[loca3]; break; endif;
/* loca3; "loca3 - wait" wait; */
endo; @ i9 @
if loca3.==-9; goto flag1; endif;

ex=(dat[i7,1 6].==st_inc[i8,1 2]); @ year and state @
/*
format /rd 10,0; dat[i7,1 6]~st_inc[i8,1 2];
if sumc(ex) ne 1; "ERROR (check selection of columns -- wait" wait; endif;
*/
dat[i7,(cols(dat)-7):cols(dat)]=st_inc[i8,(cols(st_inc)-7):cols(st_inc)];
                  @ last eight rows of each dataset @
flag1:endo; @ i7 @

   if     i5==1; create f3=^dtset3 with ^vnames,cols(dat),8;
                 call writer(f3,dat);
                 f3=close(f3);
                 min_=minc(dat); max_=maxc(dat);
   elseif i5==2; open f3=^dtset3 for append; @ file bleibt offen @
                 call writer(f3,dat);
                 min_=minc(min_'|(minc(dat))');
                 max_=maxc(max_'|(maxc(dat))');
   else;         call writer(f3,dat);
                 min_=minc(min_'|(minc(dat))');
                 max_=maxc(max_'|(maxc(dat))');
   endif;

endo; @ read until eof @

f5=close(f5);
f3=close(f3);
clear f5,f3;
clear exvec, dat;

format /rd 12,0;
open f1=^dtset1 for read;
rw1=rowsf(f1);
f1=close(f1);
"orig number of obs:" rw1; clear rw1,f1;

open f3=^dtset3 for read;
rw3=rowsf(f3);
f3=close(f3);
"number of obs left:" rw3; clear rw3,f3;

"minimum vector:" min_;
"maximum vector:" max_;

dos del merge17.d?t;
dos del temp.d?t;
dos pkzip -3 -)  d:\data\cu1\gauss\merge18.zip
           d:\data\cu1\gauss\merge18.d?t;
dos del    d:\data\cu1\gauss\merge18.d?t;

@------------------------------------------------------------------@

@ eliminate cus which did not match @

dos pkunzip -3 -) d:\data\cu1\gauss\merge18.zip c:\prg\cu1;
dtset3="merge18";
dtset4="d:\\data\\cu1\\gauss\\merge19";

step=5e2;
open f3=^dtset3 for read;
rw3=rowsf(f3);
i5=0; i6=0; @ i5,i6: Zaehler; nicht aendern @
do until eof(f3);
i6=i6+1;

if i6==0 or i6==5; i6=0;
format /rd 6,0; locate 6,1;
1e2.*minc((i5.*step)|rw3)./rw3;; "percent done";
endif;

dat=readr(f3,step);
/* dat[.,cols(dat)]; i5; wait; */

@ eliminate 'non-matches', i.e. '-9's; [there are no missing values
  in the state income/product dataset] @
exvec=  (dat[.,cols(dat)]./=-9);  @ no match @
/* format /rd 4,0; exvec'; wait; */

if sumc(exvec).>=1; i5=i5+1;

   dat=selif(dat,exvec);

   if     i5==1; create f4=^dtset4 with ^vnames,cols(dat),8;
                 call writer(f4,dat);
                 f4=close(f4);
                 min_=minc(dat); max_=maxc(dat);
   elseif i5==2; open f4=^dtset4 for append; @ file bleibt offen @
                 call writer(f4,dat);
                 min_=minc(min_'|(minc(dat))');
                 max_=maxc(max_'|(maxc(dat))');
   else;         call writer(f4,dat);
                 min_=minc(min_'|(minc(dat))');
                 max_=maxc(max_'|(maxc(dat))');
   endif;
endif;

endo; @ read until eof @

f3=close(f3);
f4=close(f4);
clear f3,f4;
clear exvec, dat;

format /rd 12,0;
open f3=^dtset3 for read;
rw3=rowsf(f3);
f3=close(f3);
"orig number of obs:" rw3; clear f3,rw3;

open f4=^dtset4 for read;
rw4=rowsf(f4);
f4=close(f4);
"number of obs left:" rw4; clear f4,rw4;

format /rd 16,6;
"minimum vector:" min_;
"maximum vector:" max_;

dos del merge18.d?t;
dos pkzip -3 -)  d:\data\cu1\gauss\merge19.zip
           d:\data\cu1\gauss\merge19.d?t;
dos del    d:\data\cu1\gauss\merge19.d?t;

@------------------------------------------------------------------@

@ datset gets sorted by year~charter# @

@ Lesen der Daten @

dos pkunzip -3 -) d:\data\cu1\gauss\merge19.zip c:\prg\cu1;
dtset4="merge19";
dtset5="d:\\data\\cu1\\gauss\\merge20";

open f4=^dtset4 for read;
rw4=rowsf(f4);
format /rd 8,0; "number of obs before sorting:" rw4;
dat=readr(f4,rw4);
f4=close(f4);
clear f4;

v=1|3; dat=rev(sortmc(dat,v)); @ year and charter # @

create f5=^dtset5 with ^vnames,cols(dat),8;
call writer(f5,dat);
f5=close(f5);
format /rd 8,0; "number of obs after sorting:" rows(dat);

"number of columns in dataset:" cols(dat);
format /rd 10,4;
"Mininimum values of added variables:";
minc(dat[.,cols(dat)-7:cols(dat)]);
"Maximum values of added variables:";
maxc(dat[.,cols(dat)-7:cols(dat)]);
@ clear f5, dat; @

dos del    merge19.d?t;
dos pkzip -3 -)  d:\data\cu1\gauss\merge20.zip
           d:\data\cu1\gauss\merge20.d?t;
dos del    d:\data\cu1\gauss\merge20.d?t;

end;
