@ Programm cu16.prg @

/* this file has to be updated if a new dataset is used;
   the section that is to be updated is marked by *** */

/* this file eliminates obs such as zero valus for
   - TA
   - wages
   - total number of employees (full time plus part time)
   - averaged TA;
   - lagged TA
   - lagged number of members
        (gets eliminated if there is only one member or less because
         ML estimation demands ln(ln(mem)), which is not defined
         for mem=1)
   - lagged number of potential members
        (gets eliminated if there is only one member or less because
         ML estimation demands ln(ln(mem)), which is not defined
         for mem=1)

   - herf equal to unity (Tobit problem); lagged herf=0 does not get
     eliminated
/*
   - participation rate equal to unity (Tobit problem);
     lagged participation rate equal to zero does not get eliminated
*/
   - unwelcome tom codes;
   writes cleaned-up file into merge21;
   gives internal firm-ids for nwpool1.prg and writes into "merge22";
   the file generates year dummies; writes them into "years";
   the file generates state dummies; writes them into "states";
   the file generates tom code dummies and writes them into "tcodes";
   files "years", "states" & "tcodes" have year in first, and new firm
   id in second column;
   tom codes get aggregated;
   prepares anndat;
   runs checks;
*/

new; #lineson;
save path=d:\data\cu1\gauss;
output file=c:\prg\cu1\cu16.out reset;
screen on; @ output off; @

dstr=datestr(0); tstr=timestr(0);
cls;
"GAUSS                                   date (US)" dstr;; "  ";; tstr;
?;"input file: cu16.prg";?;

@ the following options must be set equal to unity for the common bond paper @
tom20 =1; @ 1: include tom codes # 20 & 50 @
edmigo=1; @ 1: include educational, military and government credit unions @
aggtom=1; @ 1: aggregate tom codes @

vnames="xx";
@ old file @
dtset1="merge20";
@ new files @
dtset6="d:\\data\\cu1\\gauss\\merge21";
dtset7="d:\\data\\cu1\\gauss\\merge22";
dtset3a="year_";
dtset4a="state_";
dtset5a="tcode_";
dtset3="d:\\data\\cu1\\gauss\\years";
dtset4="d:\\data\\cu1\\gauss\\states";
dtset5="d:\\data\\cu1\\gauss\\tcodes";
dtset8="d:\\data\\cu1\\gauss\\inter";   @ annual interest rates @
dtset8a="d:\\data\\cu1\\gauss\\anndat"; @ annual data, such as int. rates @

@ --- part 0: clean file and write merge21, year_, sate_, tcode_ --- @

dos pkunzip -3 -) d:\data\cu1\gauss\merge20.zip c:\prg\cu1;

open f1=^dtset1 for read;
rw1=rowsf(f1);

let sv = 1 1 25 80 0 7; scroll sv; locate 5,1;
"...currently working on merge21...";

step=1e3;
i5=0; i6=0; @ i5,i6: Zaehler; nicht aendern @
do until eof(f1);
i6=i6+1;

if i6==0 or i6==1; i6=0;
output off; screen on; format /rd 6,0; locate 6,1;
1e2.*minc((i5.*step)|rw1)./rw1;; "percent done";
output on; endif;

dat=readr(f1,step);
@ cols(dat); wait; @

@ TA, lagged TA; employee compensation; operating expenses @
exvec1=(minc(dat[.,15 31]').>0);

@ lagged members / lagged potential members @
exvec13=(minc(dat[.,32 33]').>1); @ > 1 @
/*
@ # of employees @
exvec2=(sumc(dat[.,11 12]').>0);
*/
@ herf=1 (Tobit problem) @
exvec2=(dat[.,36].<1);

@ choose credit unions: manufacturing and services @
exvec3 = dat[.,4].==4;                    @ educational; single group @
exvec4 = dat[.,4].==5;                    @ military; single group @
exvec5 = dat[.,4].==6;                    @ government; single group @
exvec6 =(dat[.,4].>=10).*(dat[.,4].<=15); @ manufacturing; single group @
if tom20.==1;
   exvec7 =(dat[.,4].>=20).*(dat[.,4].<=23); @ services; single group @
else;
   exvec7 =(dat[.,4].>=21).*(dat[.,4].<=23); @ without tom code 20 @
endif;
exvec8 =(dat[.,4].>=40).*(dat[.,4].<=49); @ manufacturing; multiple group @
if tom20.==1;
   exvec9 =(dat[.,4].>=50).*(dat[.,4].<=53); @ services; multiple group @
else;
   exvec9 =(dat[.,4].>=51).*(dat[.,4].<=53); @ without tom code 50 @
endif;
exvec10= dat[.,4].==34;                   @ educational; multiple group @
exvec11= dat[.,4].==35;                   @ military; multiple group @
exvec12= dat[.,4].==36;                   @ government; multiple group @

if edmigo./=1; clear exvec3,exvec4,exvec5,exvec10,exvec11,exvec12; endif;

exvec=  (exvec1.*exvec2.*exvec13)
      .*( exvec3+exvec4+exvec5+exvec6+exvec7+exvec8+exvec9+exvec10+exvec11
         +exvec12);
clear exvec1,exvec2, exvec3, exvec4, exvec5, exvec6,exvec7,exvec8;
clear exvec9,exvec10,exvec11,exvec12;
if sumc(exvec).>=1; i5=i5+1;

   dat=selif(dat,exvec); clear exvec;


   if     i5==1; create f6=^dtset6 with ^vnames,cols(dat),8;
                 call writer(f6,dat);
                 f6=close(f6);
                 create f3a=^dtset3a with ^vnames,2,8;
                 call writer(f3a,dat[.,1 3]); @ year @
                 f3a=close(f3a);
                 create f4a=^dtset4a with ^vnames,3,8;
                 call writer(f4a,dat[.,1 3 6]); @ state id @
                 f4a=close(f4a);
                 create f5a=^dtset5a with ^vnames,3,8;
                 call writer(f5a,dat[.,1 3 4]); @ tom code @
                 f5a=close(f5a);
                 min_=minc(dat); max_=maxc(dat);
   elseif i5==2; open f6=^dtset6 for append;
                 call writer(f6,dat);
                 open f3a=^dtset3a for append;
                 call writer(f3a,dat[.,1 3]); @ year @
                 open f4a=^dtset4a for append;
                 call writer(f4a,dat[.,1 3 6]); @ state id @
                 open f5a=^dtset5a for append;
                 call writer(f5a,dat[.,1 3 4]); @ tom code @
                 min_=minc(min_'|(minc(dat))');
                 max_=maxc(max_'|(maxc(dat))');
   else;         call writer(f6,dat);
                 call writer(f3a,dat[.,1 3]); @ year, charter# @
                 call writer(f4a,dat[.,1 3 6]); @ year, state id, charter# @
                 call writer(f5a,dat[.,1 3 4]); @ ...,tom code @
                 min_=minc(min_'|(minc(dat))');
                 max_=maxc(max_'|(maxc(dat))');
   endif;
endif;

endo; @ read until eof @

f1=close(f1);
f6=close(f6);
f3a=close(f3a);
f4a=close(f4a);
f5a=close(f5a);
clear f1,f2,f3a,f4a,f5a;
clear dat;

format /rd 12,0;
open f1=^dtset1 for read;
rw1=rowsf(f1);
f1=close(f1);
"orig number of obs:" rw1; clear rw1,f1;

open f6=^dtset6 for read;
rw6=rowsf(f6);
f6=close(f6);
"number of obs left:" rw6; clear rw6,f6;

"minimum vector:" min_;
"maximum vector:" max_;

dos del merge20.d?t;
dos pkzip -3 -) d:\data\cu1\gauss\merge21.zip
                 d:\data\cu1\gauss\merge21.d?t;
dos del          d:\data\cu1\gauss\merge21.d?t;

@ --- part 1: new firm ids into column 2 --- @

@ replaces charter numbers by sequential firm ids @

dos pkunzip -3 -) d:\data\cu1\gauss\merge21.zip c:\prg\cu1;
dtset6="merge21";  @ reset dtset6 @

open f6=^dtset6 for read;
rw6=rowsf(f6);
dat=readr(f6,rw6);
f6=close(f6);
clear f6;

charter=unique(dat[.,3],1);
i=0;
do while i<rows(charter);
i=i+1;
vec_=indexcat(dat[.,3],charter[i]);
dat[vec_,2]=i.*ones(rows(vec_),1);  @ second column @
endo;

dat[1 2,1:4]; @ wait; @

create f7=^dtset7 with ^vnames,cols(dat),8;
call writer(f7,dat);
f7=close(f7);
/* cols(dat); "wait"; wait; */
clear f7, dat;

dos del merge21.d?t;

@------------ part 2: the year dummies ------------------------------@

open f8=^dtset8 for read;
rw8=rowsf(f8);
anndat=readr(f8,rw8); @ annual data (interest rates) @
f8=close(f8);
clear f8;

open f3a=^dtset3a for read;
rw3a=rowsf(f3a);
dat=readr(f3a,rw3a);
f3a=close(f3a);
clear f3a;
crit=unique(dat[.,1],1); @ vorkommende Jahre @
@ format /rd 6,0; "years covered: ";; crit'; wait; @
crit=sortc(crit,1);
format /rd 6,0; "years covered:" crit'; @ wait; @
if minc(crit)<1989 or maxc(crit)>1996; "ERROR(1) -- wait"; wait; endif;

exann=sumc((anndat[.,1].==crit')'); @ pick the years from the annual data @
"exann': ";; exann'; @ wait; @
anndat=selif(anndat,exann);
anndat=anndat[.,2:cols(anndat)]; @ delete first column (year info) @

open f3a=^dtset3a for read;
rw3a=rowsf(f3a);
open f7=^dtset7 for read;
rw7=rowsf(f7);

let sv = 1 1 25 80 0 7; scroll sv; locate 5,1;
"...currently working on years...";

step=1e3;
i5=0; i6=0; @ i5,i6: Zaehler; nicht aendern @
do until eof(f3a);
i6=i6+1;

if i6==0 or i6==1; i6=0;
output off; screen on; format /rd 6,0; locate 6,1;
1e2.*minc((i5.*step)|rw3a)./rw3a;; "percent done";
output on; endif;

dat=readr(f3a,step);
id=readr(f7,step); dat[.,2]=id[.,2]; clear id; @ firm id @

exvec=(dat[.,1].==crit'); @ year dummies @
dat=dat~exvec;
i5=i5+1;

   if     i5==1; create f3=^dtset3 with ^vnames,cols(dat),8;
                 call writer(f3,dat);
                 f3=close(f3);
                 min_=minc(dat); max_=maxc(dat);
   elseif i5==2; open f3=^dtset3 for append;
                 call writer(f3,dat);
                 min_=minc(min_'|(minc(dat))');
                 max_=maxc(max_'|(maxc(dat))');
   else;         call writer(f3,dat);
                 min_=minc(min_'|(minc(dat))');
                 max_=maxc(max_'|(maxc(dat))');
   endif;

endo; @ read until eof @

f3a=close(f3a);
f3=close(f3);
f7=close(f7);
clear dat;

@ generate anndat (annual data, such as interest rates) @

open f3=^dtset3 for read;
rw3=rowsf(f3);
years=readr(f3,rw3); @ year dummies @
f3=close(f3);
clear f3;
years[1:2,.]; @ wait; @
years=years[.,3:cols(years)]; @ chop off first two columns @

if sumc(years') ne ones(rows(years),1); "ERROR(4)--wait"; wait; endif;

i=0;
do while i<cols(anndat);
i=i+1;
annmat=years;
j=0;
do while j<cols(years);
j=j+1; i~j;
annmat[.,j]=annmat[.,j].*anndat[j,i];
endo;  @ j @
if i==1; annmat_=sumc(annmat'); else; annmat_=annmat_~sumc(annmat'); endif;
endo;  @ i @

create f8a=^dtset8a with ^vnames,cols(annmat_),8;
call writer(f8a,annmat_);
f8a=close(f8a);

dos del year_.d?t;
dos pkzip -3 -) d:\data\cu1\gauss\years.zip
                d:\data\cu1\gauss\years.d?t;
dos del         d:\data\cu1\gauss\years.d?t;

@------------ part 3: the states dummies ------------------------------@

open f4a=^dtset4a for read;
rw4a=rowsf(f4a);
dat=readr(f4a,rw4a);
f4a=close(f4a);
clear f4a;
crit=unique(dat[.,cols(dat)],1); @ vorkommende Staaten @
crit=sortc(crit,1);
format /rd 6,0; "state codes:" crit'; @ wait; @
if maxc(crit)>56 or minc(crit)<1; "ERROR(2a) -- wait"; wait; endif;
if rows(crit)>51; "ERROR(2b) -- wait"; wait; endif;

open f4a=^dtset4a for read;
rw4a=rowsf(f4a);
open f7=^dtset7 for read;
rw7=rowsf(f7);

let sv = 1 1 25 80 0 7; scroll sv; locate 5,1;
"...currently working on states...";

step=1e3;
i5=0; i6=0; @ i5,i6: Zaehler; nicht aendern @
do until eof(f4a);
i6=i6+1;

if i6==0 or i6==1; i6=0;
output off; screen on; format /rd 6,0; locate 6,1;
1e2.*minc((i5.*step)|rw4a)./rw4a;; "percent done";
output on; endif;

dat=readr(f4a,step);
id=readr(f7,step); dat[.,2]=id[.,2]; clear id; @ firm id @

exvec=(dat[.,cols(dat)].==crit'); @ state dummies @
dat=dat~exvec;
i5=i5+1;

   if     i5==1; create f4=^dtset4 with ^vnames,cols(dat),8;
                 call writer(f4,dat);
                 f4=close(f4);
                 min_=minc(dat); max_=maxc(dat);
   elseif i5==2; open f4=^dtset4 for append;
                 call writer(f4,dat);
                 min_=minc(min_'|(minc(dat))');
                 max_=maxc(max_'|(maxc(dat))');
   else;         call writer(f4,dat);
                 min_=minc(min_'|(minc(dat))');
                 max_=maxc(max_'|(maxc(dat))');
   endif;

endo; @ read until eof @

f4a=close(f4a);
f4=close(f4);
f7=close(f7);
clear dat;

dos del state_.d?t;
dos pkzip -3 -) d:\data\cu1\gauss\states.zip
                d:\data\cu1\gauss\states.d?t;
dos del         d:\data\cu1\gauss\states.d?t;

@------------ part 4: the tom code dummies ---------------------------@

open f5a=^dtset5a for read;
rw5a=rowsf(f5a);
dat=readr(f5a,rw5a);
f5a=close(f5a);
clear f5a;
@ tom codes that show @
crit=unique(dat[.,cols(dat)],1); @ vorkommende tom codes @
crit=sortc(crit,1);
format /rd 6,0; "tom codes that show:" crit';
if maxc(crit)>99 or minc(crit)<0; "ERROR(3) -- wait"; wait; endif;
if aggtom.==1;
   crit=seqa(1,1,10); @ will aggregate into 10 tom code categories @
endif;
format /rd 6,0; "tom codes will be grouped into:" crit'; @ wait; @

open f5a=^dtset5a for read;
rw5a=rowsf(f5a);
open f7=^dtset7 for read;
rw7=rowsf(f7);

let sv = 1 1 25 80 0 7; scroll sv; locate 5,1;
"...currently working on tom codes...";

step=1e3;
i5=0; i6=0; @ i5,i6: Zaehler; nicht aendern @
do until eof(f5a);
i6=i6+1;

if i6==0 or i6==1; i6=0;
output off; screen on; format /rd 6,0; locate 6,1;
1e2.*minc((i5.*step)|rw5a)./rw5a;; "percent done";
output on; endif;

dat=readr(f5a,step);
id=readr(f7,step); dat[.,2]=id[.,2]; clear id; @ firm id @

if aggtom.==1; @ aggregate tom codes @
i=0;
do while i<rows(dat);
i=i+1;

    if dat[i,cols(dat)]==4;  dat[i,cols(dat)]=1;
elseif dat[i,cols(dat)]==5;  dat[i,cols(dat)]=2;
elseif dat[i,cols(dat)]==6;  dat[i,cols(dat)]=3;
elseif dat[i,cols(dat)]==34; dat[i,cols(dat)]=6;
elseif dat[i,cols(dat)]==35; dat[i,cols(dat)]=7;
elseif dat[i,cols(dat)]==36; dat[i,cols(dat)]=8;

elseif dat[i,cols(dat)] ge 10 and dat[i,cols(dat)] le 15;dat[i,cols(dat)]= 4;
elseif dat[i,cols(dat)] ge 20 and dat[i,cols(dat)] le 23;dat[i,cols(dat)]= 5;
elseif dat[i,cols(dat)] ge 40 and dat[i,cols(dat)] le 49;dat[i,cols(dat)]= 9;
elseif dat[i,cols(dat)] ge 50 and dat[i,cols(dat)] le 53;dat[i,cols(dat)]=10;

endif;
endo;

endif; @ aggtom @

exvec=(dat[.,cols(dat)].==crit'); @ tom code dummies @
dat=dat~exvec;
i5=i5+1;

   if     i5==1; create f5=^dtset5 with ^vnames,cols(dat),8;
                 call writer(f5,dat);
                 f5=close(f5);
                 min_=minc(dat); max_=maxc(dat);
   elseif i5==2; open f5=^dtset5 for append;
                 call writer(f5,dat);
                 min_=minc(min_'|(minc(dat))');
                 max_=maxc(max_'|(maxc(dat))');
   else;         call writer(f5,dat);
                 min_=minc(min_'|(minc(dat))');
                 max_=maxc(max_'|(maxc(dat))');
   endif;

endo; @ read until eof @

f5a=close(f5a);
f5=close(f5);
f7=close(f7);
format /rd 5,0; "# of columns in dataset -- wait: " cols(dat); wait;
clear dat;

dos del tcode_.d?t;
dos pkzip -3 -) d:\data\cu1\gauss\tcodes.zip
                d:\data\cu1\gauss\tcodes.d?t;
dos del         d:\data\cu1\gauss\tcodes.d?t;

@------------------------------------------------------------------@

dos pkzip -3 -) d:\data\cu1\gauss\merge22.zip
                 d:\data\cu1\gauss\merge22.d?t;
dos del          d:\data\cu1\gauss\merge22.d?t;

end;
