@ Programm cu2.prg @

/* this file reads cuacct;
   it eliminates June reporting; eliminates charter #s 60000 and higher @
   it eliminates all obs with an activity code different from zero @
   it runs checks;
   it writes a files named cuacct1;
   it reads in cuacct1, eliminates nonpositive values for ta,
   sorts it and writes it into cuacct2
   it reads in cuacct2 and calculates over the year averages for ta;
   it appends average ta, lagged ta, lagged # of (actual and pot.) mems
   writes out cuacct3 */

new; #lineson;
save path=d:\data\cu1\gauss;
output file=c:\prg\cu1\cu2.out reset;
screen on; @ output off; @

dstr=datestr(0); tstr=timestr(0);
cls;
"GAUSS                                   date (US)" dstr;; "  ";; tstr;
?;"input file: cu2.prg";?;

vnames="xx";

@ Lesen der Daten @

dtset3="d:\\data\\cu1\\gauss\\cuacct1";

dos pkunzip -3 -) d:\data\cu1\gauss\cuacct.zip c:\prg\cu1;
dtset1="cuacct";
open f1=^dtset1 for read;
rw1=rowsf(f1);

let sv = 1 1 25 80 0 7; scroll sv; locate 5,1;
"...currently working on cuacct...";

step=1e3;
i5=0; i6=0; i7=0; @ i5,i6,i7: Zaehler; nicht aendern @
do until eof(f1);
i6=i6+1; i7=i7+1;

if i6.==0 or i6.==5; i6=0;
output off; screen on; format /rd 6,0; locate 6,1;
1e2.*minc((i5.*step)|rw1)./rw1;; "percent done";
output on; endif;

dat=readr(f1,step);

   if i7.==1;
     fips_cu2=dat[.,8]; @ fips code (for matters of counting only) @
   else;
     fips_cu2=fips_cu2|dat[.,8];
   endif;

exvec1=(
        (dat[.,1]./1e4)-floor(dat[.,1]./1e4).>0.07
        ); @ eliminate June @
exvec2=(dat[.,2].<60000); @ charter # @
exvec3=(dat[.,19].==0); @ activity code @
exvec=(exvec1.*exvec2).*exvec3; clear exvec1, exvec2, exvec3;

if sumc(exvec).>=1; i5=i5+1;

   dat=selif(dat,exvec);
   dat[.,1]=floor(dat[.,1]./1e4); @ year @
   @ dat[.,1]'; @

   if     i5==1; create f3=^dtset3 with ^vnames,cols(dat),8;
                 call writer(f3,dat);
                 f3=close(f3);
                 min_=minc(dat); max_=maxc(dat);
   elseif i5==2; open f3=^dtset3 for append; @ file bleibt offen @
                 call writer(f3,dat);
                 min_=minc(min_'|(minc(dat))');
                 max_=maxc(max_'|(maxc(dat))');
   else;         call writer(f3,dat);
                 min_=minc(min_'|(minc(dat))');
                 max_=maxc(max_'|(maxc(dat))');
   endif;
endif;

endo; @ read until eof @

f1=close(f1);
f3=close(f3);
clear f1,f3;
@ clear exvec, dat;  @
save fips_cu2;
format /rd 10,0; "number of fips codes in dataset:" rows(unique(fips_cu2,1));
clear fips_cu2;

@--------------------@

format /rd 12,0;
open f1=^dtset1 for read;
rw1=rowsf(f1);
f1=close(f1);
"orig number of obs:" rw1;

open f3=^dtset3 for read;
rw3=rowsf(f3);
f3=close(f3);
"number of obs left:" rw3;

"minimum vector:" min_;
"maximum vector:" max_;

@--------------------@

dos del cuacct.d?t;
dos pkzip -3 -)  d:\data\cu1\gauss\cuacct1.zip
           d:\data\cu1\gauss\cuacct1.d?t;
dos del    d:\data\cu1\gauss\cuacct1.d?t;

@-----------------------------------------------------------------------@

@ datset gets sorted by year~charter# @

@ Lesen der Daten @

dtset3="d:\\data\\cu1\\gauss\\cuacct2";

dos pkunzip -3 -) d:\data\cu1\gauss\cuacct1.zip c:\prg\cu1;
dtset1="cuacct1";
open f1=^dtset1 for read;
rw1=rowsf(f1);
dat=readr(f1,rw1);
f1=close(f1);
clear f1;

dat=selif(dat,dat[.,15].>0); @ eliminate nonpositive values @
v=1|3; dat=sortmc(dat,v);  @ year~charter# @

create f3=^dtset3 with ^vnames,cols(dat),8;
call writer(f3,dat);
f3=close(f3);
clear f3, dat;

dos del cuacct1.d?t;
dos pkzip -3 -)  d:\data\cu1\gauss\cuacct2.zip
           d:\data\cu1\gauss\cuacct2.d?t;
dos del    d:\data\cu1\gauss\cuacct2.d?t;

@-----------------------------------------------------------------------@

@ calculate annual averages for TA (total assets) @

dtset6="temp";
dtset5="d:\\data\\cu1\\gauss\\cuacct3";

dos pkunzip -3 -) d:\data\cu1\gauss\cuacct2.zip c:\prg\cu1;
dtset4="cuacct2";
open f4=^dtset4 for read;
rw4=rowsf(f4);
dat=readr(f4,rw4);
f4=close(f4);

dat=dat[.,1 3 15 9 10]; @ year~charter#~ta~member~PotMem @
ata=dat[.,1 2]~(-9.*ones(rows(dat),4));
              @ year~charter~ta-average~lagTA~lagMember~lagPotMem @

years=unique(dat[.,1],1); @ years @
chnum=unique(dat[.,2],1); @ charter numbers @

i=0; i6=0;
do while i<rows(chnum);
i=i+1;
crit1=chnum[i];               @ select charter number @
ex1=indexcat(dat[.,2],crit1); @ location of charter number @
charter=dat[ex1,.];           @ select obs with this charter number @
@ charter; wait; @
j=0;
do while j<rows(years)-1;
j=j+1;
crit2=years[j j+1]; @ select years @
@ crit1'; crit2'; @
@ charter; wait; @
ex2= indexcat(charter[.,1],crit2[1])  @ z.B. 1995 @
    |indexcat(charter[.,1],crit2[2]); @ z.B. 1996 @
ex2=missrv(ex2,-9); @ missing value code @
@ "ex2 -- wait: "  ex2';  wait; @
if minc(ex2)>0; ata[ex1[ex2[2]],3]  =meanc(charter[ex2,3]); @ average @
                ata[ex1[ex2[2]],4:6]=      charter[ex2[1],3:5];
                             @ lagged values: TA, members, pot. members @
@ ata[ex1[ex2[2]],3:6]; wait; @
endif;
endo;
i6=i6+1; if i6==1e2; i6=0;
   output off; screen on; format /rd 6,0; locate 6,1;
   (100.*i)./rows(chnum);; "percent done"; output on;
endif;
endo;
"selected TAs:"
dat[(rows(dat)-50):rows(dat),.];?;
"selected averages (TA) & lags (TA, members):"
ata[(rows(dat)-50):rows(dat),.];

create f6=^dtset6 with ^vnames,cols(ata),8;
call writer(f6,ata);
f6=close(f6);
clear f6;
ex=(ata[.,3].==-9); format /rd 8,0;
"number of obs on file:" rows(ata);
"number of obs with missing values:" sumc(ex);
clear ata, ex, chnum, years, charter;

@ append annual averages of TA to the accounting data @

open f4=^dtset4 for read;
rw4=rowsf(f4);
dat=readr(f4,rw4);
f4=close(f4);
clear f4;

open f6=^dtset6 for read;
rw6=rowsf(f6);
ata_=readr(f6,rw6);
f6=close(f6);
clear f6;

dat=dat~ata_[.,3:cols(ata_)];
format /rd 12,0;
"Min and Max of TA:";
 minc(dat[.,15])~maxc(dat[.,15]);
"Min and Max of averaged TA:";
 minc(dat[.,cols(dat)-3])~maxc(dat[.,cols(dat)-3]);
"Min and Max of lagged TA:";
minc(dat[.,cols(dat)-2])~maxc(dat[.,cols(dat)-2]);
?
"Min and Max of number of members:";
 minc(dat[.,9])~maxc(dat[.,9]);
"Min and Max of lagged number of members:";
minc(dat[.,cols(dat)-1])~maxc(dat[.,cols(dat)-1]);
?
"Min and Max of number of potential members:";
 minc(dat[.,10])~maxc(dat[.,10]);
"Min and Max of lagged number of members:";
minc(dat[.,cols(dat)])~maxc(dat[.,cols(dat)]);

create f5=^dtset5 with ^vnames,cols(dat),8;
call writer(f5,dat);
f5=close(f5);
clear f5 @, dat, ata_ @;

dos del cuacct2.d?t;
dos del temp.d?t;
dos pkzip -3 -)  d:\data\cu1\gauss\cuacct3.zip
           d:\data\cu1\gauss\cuacct3.d?t;
dos del    d:\data\cu1\gauss\cuacct3.d?t;

@-----------------------------------------------------------------------@

end;
