@ Programm cu3.prg @

/* this file reads wages;
   makes years year-2000 compliant;
   eliminates zero values for "repu", "emp" and "wages";
   it runs checks;
   it writes a files named wages1;
   it reads in wages1 and sorts it; writes out wages2 */

new; #lineson;
save path=d:\data\cu1\gauss;
output file=c:\prg\cu1\cu3.out reset;
screen on; @ output off; @

dstr=datestr(0); tstr=timestr(0);
cls;
"GAUSS                                   date (US)" dstr;; "  ";; tstr;
?;"input file: cu3.prg";?;

vnames="xx";
dtset3="d:\\data\\cu1\\gauss\\wages1";

@ Lesen der Daten @

dos pkunzip -3 -) d:\data\cu1\gauss\wages.zip c:\prg\cu1;
dtset1="wages";
open f1=^dtset1 for read;
rw1=rowsf(f1);

let sv = 1 1 25 80 0 7; scroll sv; locate 5,1;
"...currently working on wages...";

step=1e3;
i5=0; i6=0; @ i5,i6: Zaehler; nicht aendern @
do until eof(f1);
i6=i6+1;

if i6==0 or i6==5; i6=0;
format /rd 6,0; locate 6,1;
1e2.*minc((i5.*step)|rw1)./rw1;; "percent done";
endif;

dat=readr(f1,step);

exvec=(((dat[.,3].>0).*(dat[.,4].>0)).*(dat[.,5].>0));

if sumc(exvec).>=1; i5=i5+1;

   dat=selif(dat,exvec);
   dat[.,1]=1900+dat[.,1]; @ year 2000 compliant @

   if     i5==1; create f3=^dtset3 with ^vnames,cols(dat),8;
                 call writer(f3,dat);
                 f3=close(f3);
                 min_=minc(dat); max_=maxc(dat);
   elseif i5==2; open f3=^dtset3 for append; @ file bleibt offen @
                 call writer(f3,dat);
                 min_=minc(min_'|(minc(dat))');
                 max_=maxc(max_'|(maxc(dat))');
   else;         call writer(f3,dat);
                 min_=minc(min_'|(minc(dat))');
                 max_=maxc(max_'|(maxc(dat))');
   endif;
endif;

endo; @ read until eof @

f1=close(f1);
f3=close(f3);
clear f1,f3;
@ clear exvec, dat;  @

format /rd 12,0;
open f1=^dtset1 for read;
rw1=rowsf(f1);
f1=close(f1);
"orig number of obs:" rw1;

open f3=^dtset3 for read;
rw3=rowsf(f3);
f3=close(f3);
"number of obs left:" rw3;

"minimum vector:" min_;
"maximum vector:" max_;

dos del wages.d?t;
dos pkzip -3 -)  d:\data\cu1\gauss\wages1.zip
           d:\data\cu1\gauss\wages1.d?t;
dos del    d:\data\cu1\gauss\wages1.d?t;

@-----------------------------------------------------------------------@

@ datset gets sorted by year~county @

@ Lesen der Daten @

dtset3="d:\\data\\cu1\\gauss\\wages2";

dos pkunzip -3 -) d:\data\cu1\gauss\wages1.zip c:\prg\cu1;
dtset1="wages1";
open f1=^dtset1 for read;
rw1=rowsf(f1);
dat=readr(f1,rw1);
f1=close(f1);
clear f1;

v=1|2; dat=sortmc(dat,v); @ year and county @

create f3=^dtset3 with ^vnames,cols(dat),8;
call writer(f3,dat);
f3=close(f3);
clear f3, dat;

dos del wages1.d?t;
dos pkzip -3 -)  d:\data\cu1\gauss\wages2.zip
           d:\data\cu1\gauss\wages2.d?t;
dos del    d:\data\cu1\gauss\wages2.d?t;

@-----------------------------------------------------------------------@

end;
