@ Programm cu4.prg @

/* this file reads
   - the herfindahls
   - county population
   - land areas;
   organizes the datasets similar to "wages";
   changes date entries to full years (year-2000 compliant);
   it runs checks;
   obs with zero herfs are eliminated from herf file only
   (one county, two years);
   sorts the datasets and writes files named
   - herf1
   - pop2
   - land1
*/

new; #lineson;
save path=d:\data\cu1\gauss;
output file=c:\prg\cu1\cu4.out reset;
screen on; @ output off; @

dstr=datestr(0); tstr=timestr(0);
cls;
"GAUSS                                   date (US)" dstr;; "  ";; tstr;
?;"input file: cu4.prg";?;

vnames="xx";
dtset3="d:\\data\\cu1\\gauss\\herf1";

@ Lesen der Daten @

dos pkunzip -3 -) d:\data\cu1\gauss\herf.zip c:\prg\cu1;
dtset1="herf";
open f1=^dtset1 for read;
rw1=rowsf(f1);
dat=readr(f1,rw1);
f1=close(f1);
clear f1;

dat=floor(dat[.,1]./1e4)~dat[.,4]~(dat[.,5]./1e4);

format /rd 12,6;
"herf -- before cleaning up";
"minimum vector:" minc(dat);
"maximum vector:" maxc(dat);

ex=(dat[.,3].==0);
if sumc(ex)>0; dat=delif(dat,ex); endif;
v=1|2; dat=sortmc(dat,v); @ year and county @

format /rd 12,6;
"herf -- after cleaning up";
"minimum vector:" minc(dat);
"maximum vector:" maxc(dat);

create f3=^dtset3 with ^vnames,cols(dat),8;
call writer(f3,dat);
f3=close(f3);

clear f3,dat;

dos del herf.d?t;
dos pkzip -3 -)  d:\data\cu1\gauss\herf1.zip
           d:\data\cu1\gauss\herf1.d?t;
dos del    d:\data\cu1\gauss\herf1.d?t;

@------------------------------------------------------------------------@

dtset3="d:\\data\\cu1\\gauss\\pop2";

@ Lesen der Daten @

dos pkunzip -3 -) d:\data\cu1\gauss\ctypop.zip c:\prg\cu1;
dtset1="ctypop";
open f1=^dtset1 for read;
rw1=rowsf(f1);
dat=readr(f1,rw1);
f1=close(f1);
clear f1;

dat=round(1900+dat[.,1])~dat[.,2:3];

format /rd 12,6;
"county population -- before cleaning up";
"minimum vector:" minc(dat);
"maximum vector:" maxc(dat);

ex=(dat[.,2].<0); @ no FIPS code @
if sumc(ex)>0; dat=delif(dat,ex); endif;
ex=(dat[.,3].<=0);
if sumc(ex)>0; dat=delif(dat,ex); endif;
v=1|2; dat=sortmc(dat,v); @ year and county @

format /rd 12,6;
"county population -- after cleaning up";
"minimum vector:" minc(dat);
"maximum vector:" maxc(dat);

create f3=^dtset3 with ^vnames,cols(dat),8;
call writer(f3,dat);
f3=close(f3);

clear f3,dat;

dos del ctypop.d?t;
dos pkzip -3 -)  d:\data\cu1\gauss\pop2.zip
           d:\data\cu1\gauss\pop2.d?t;
dos del    d:\data\cu1\gauss\pop2.d?t;

@------------------------------------------------------------------------@

dtset3="d:\\data\\cu1\\gauss\\land1";

@ Lesen der Daten @

dos pkunzip -3 -) d:\data\cu1\gauss\land.zip c:\prg\cu1;
dtset1="land";
open f1=^dtset1 for read;
rw1=rowsf(f1);
dat=readr(f1,rw1);
f1=close(f1);
clear f1;

dat=round(1900+dat[.,1])~dat[.,2:4];

format /rd 12,6;
"land -- before cleaning up";
"minimum vector:" minc(dat);
"maximum vector:" maxc(dat);

ex=(dat[.,2].<0); @ no FIPS code @
if sumc(ex)>0; dat=delif(dat,ex); endif;
ex=(dat[.,3].<=0);
if sumc(ex)>0; dat=delif(dat,ex); endif;
ex=(dat[.,4].<=0);
if sumc(ex)>0; dat=delif(dat,ex); endif;
v=1|2; dat=sortmc(dat,v); @ year and county @

format /rd 12,6;
"land -- after cleaning up";
"minimum vector:" minc(dat);
"maximum vector:" maxc(dat);

create f3=^dtset3 with ^vnames,cols(dat),8;
call writer(f3,dat);
f3=close(f3);

clear f3,dat;

dos del land.d?t;
dos pkzip -3 -)  d:\data\cu1\gauss\land1.zip
           d:\data\cu1\gauss\land1.d?t;
dos del    d:\data\cu1\gauss\land1.d?t;

end;
