@ Programm cu5.prg @

/* what we want: growth of personal income, not of per-capita personal inc;
   this file reads 51 state-specific files with info on personal
   income by county;
   organizes the dataset similar to "wages" and "herf";
   zero values get eliminated
   option: with or without growth rates
*/

new; #lineson;
save path=d:\data\cu1\gauss;
output file=c:\prg\cu1\cu5.out reset;
screen on; @ output off; @

dstr=datestr(0); tstr=timestr(0);
cls;
"GAUSS                                   date (US)" dstr;; "  ";; tstr;
?;"input file: cu5.prg";?;

growth=0; @ 1: with growth rates for personal income @
vnames="xx";
dtset3="d:\\data\\cu1\\gauss\\persinc1";

@ Lesen der Daten @

dos pkunzip -3 -) d:\data\cu1\gauss\persinc.zip c:\prg\cu1;
i=0;
do while i<51;
i=i+1;
    if i== 1; dtset="wapi"; elseif i== 2; dtset="alpi";
elseif i== 3; dtset="orpi"; elseif i== 4; dtset="sdpi";
elseif i== 5; dtset="nvpi"; elseif i== 6; dtset="ndpi";
elseif i== 7; dtset="hipi"; elseif i== 8; dtset="nepi";
elseif i== 9; dtset="capi"; elseif i== 0; dtset="mopi";
elseif i==11; dtset="akpi"; elseif i==12; dtset="mnpi";
elseif i==13; dtset="wypi"; elseif i==14; dtset="kspi";
elseif i==15; dtset="utpi"; elseif i==16; dtset="iapi";
elseif i==17; dtset="mtpi"; elseif i==18; dtset="wipi";
elseif i==19; dtset="idpi"; elseif i==20; dtset="ohpi";
elseif i==21; dtset="copi"; elseif i==22; dtset="mipi";
elseif i==23; dtset="txpi"; elseif i==24; dtset="inpi";
elseif i==25; dtset="okpi"; elseif i==26; dtset="ilpi";
elseif i==27; dtset="nmpi"; elseif i==28; dtset="papi";
elseif i==29; dtset="azpi"; elseif i==30; dtset="nypi";
elseif i==31; dtset="wvpi"; elseif i==32; dtset="njpi";
elseif i==33; dtset="vapi"; elseif i==34; dtset="mdpi";
elseif i==35; dtset="tnpi"; elseif i==36; dtset="dcpi";
elseif i==37; dtset="scpi"; elseif i==38; dtset="depi";
elseif i==39; dtset="ncpi"; elseif i==40; dtset="vtpi";
elseif i==41; dtset="mspi"; elseif i==42; dtset="ripi";
elseif i==43; dtset="lapi"; elseif i==44; dtset="nhpi";
elseif i==45; dtset="kypi"; elseif i==46; dtset="mapi";
elseif i==47; dtset="gapi"; elseif i==48; dtset="mepi";
elseif i==49; dtset="flpi"; elseif i==50; dtset="ctpi";
elseif i==51; dtset="arpi";
endif;

open f1=^dtset for read;
rw1=rowsf(f1);
dat=readr(f1,rw1);
f1=close(f1);
clear f1;

ex=(dat[.,2].==10).*(dat[.,3].==8);
dat=selif(dat,ex);
@ rows(dat); wait; @
ys=seqa(1988,1,8); @ select 8 years: 1988-1995 @
@ ys; wait; @

j=0; @ go through all rows @
do while j<rows(dat);
j=j+1;
fips=dat[j,1].*ones(rows(ys),1);
pers  =dat[j,23:30]'; @ personal income @
pers_1=dat[j,22:29]'; @ lagged by one period @
dpers =-9.*ones(rows(pers),1); @ dummy; to be filled @
k=0;
do while k<rows(pers);
k=k+1;
if pers[k] ne 0 and pers_1[k] ne 0; dpers[k]=ln(pers[k]./pers_1[k]); endif;
                                                @ log change @
endo;

if j==1;
         if growth==1; data_=       ys~fips~pers~dpers;
         else;         data_=       ys~fips~pers;       endif;
   else;
         if growth==1; data_=data_|(ys~fips~pers~dpers);
         else;         data_=data_|(ys~fips~pers);       endif;
endif;
endo;

if i==1; data=data_; else; data=data|data_; endif;

endo;

@-----------------------------------------------------------------------@

@ eliminate zero values @
if growth==1; ex=(data[.,3].==0).*(data[.,4].==0);
else;         ex=(data[.,3].==0);                 endif;
if sumc(ex)>0; data=delif(data,ex); endif;
v=1|2; data=sortmc(data,v); @ year and county @

create f3=^dtset3 with ^vnames,cols(data),8;
call writer(f3,data);
f3=close(f3);
clear f3 @, data@;

dos del ??pi.d?t;
dos pkzip -3 -)  d:\data\cu1\gauss\persinc1.zip
           d:\data\cu1\gauss\persinc1.d?t;
dos del    d:\data\cu1\gauss\persinc1.d?t;

end;
