@ Programm cu6.prg @

/* watch cv.==1 */

/*  year~state-id (acc. to fips-code)
   ~real gross state product
   ~nominal gross state product
   ~state personal income
   ~real gsp per capita
   ~their log growth rates
*/

new; #lineson;
save path=d:\data\cu1\gauss;
output file=c:\prg\cu1\cu6.out reset;
screen on; @ output off; @

dstr=datestr(0); tstr=timestr(0);
cls;
"GAUSS                                   date (US)" dstr;; "  ";; tstr;
?;"input file: cu6.prg";?;

cv=0; @ 1: growth rate refer to 1996 vs. 1989 @
vnames="xx";
dtset3="d:\\data\\cu1\\gauss\\st_inc";

@ Lesen der Daten @

dtset1="d:\\data\\cu1\\gauss\\realgsp";
open f1=^dtset1 for read;
rw1=rowsf(f1);
realgsp=readr(f1,rw1); @ real gross state product @
f1=close(f1);
clear f1;

dtset1="d:\\data\\cu1\\gauss\\nomgsp";
open f1=^dtset1 for read;
rw1=rowsf(f1);
nomgsp=readr(f1,rw1); @ nominal gross state product @
f1=close(f1);
clear f1;

dtset1="d:\\data\\cu1\\gauss\\statepi";
open f1=^dtset1 for read;
rw1=rowsf(f1);
statepi=readr(f1,rw1); @ state personal income @
f1=close(f1);
clear f1;

dtset1="d:\\data\\cu1\\gauss\\stpop";
open f1=^dtset1 for read;
rw1=rowsf(f1);
stpop=readr(f1,rw1); @ real gross state product @
f1=close(f1);
clear f1;

@ get rid of "none-state" fips codes @

statepi=selif((statepi,statepi[.,1].<61));
stpop  =selif((stpop,stpop[.,1].<61));
stpop=stpop[.,1:cols(stpop)-1]; @ get rid of 1997 @

@ sort by state fips code @

realgsp=sortmc(realgsp,1);
nomgsp =sortmc(nomgsp,1);
statepi=sortmc(statepi,1);
stpop=sortmc(stpop,1);

@ create real gross state product per capita @

realpc=realgsp[.,1]~(realgsp[.,2:cols(realgsp)]./stpop[.,2:cols(stpop)]);

@ organize by years @

ys=seqa(1989,1,8);
@ys; wait; @
crit=unique(realgsp[.,1]|nomgsp[.,1]|statepi[.,1]|realpc[.,1],1);
i=0;
do while i<rows(crit);
i=i+1;
real_ =selif(realgsp,realgsp[.,1].==crit[i]);
nom_  =selif(nomgsp,nomgsp[.,1].==crit[i]);
state_=selif(statepi,statepi[.,1].==crit[i]);
pc_   =selif(realpc,realpc[.,1].==crit[i]);

if cv.==1; @ growth rates relative to year 1988 @
dat_= ys~(crit[i].*ones(rows(ys),1))
     ~(   real_[3:cols(real_)]'                            )
     ~(   nom_[3:cols(nom_)]'                          )
     ~(   state_[3:cols(state_)]'                              )
     ~(   pc_[3:cols(state_)]'                              )
     ~(ln( real_[cols(real_)  cols(real_)  5:cols(real_)]' ./real_[2]))
     ~(ln(  nom_[cols(nom_)   cols(nom_)   5:cols(nom_)]'  ./nom_[2]))
     ~(ln(state_[cols(state_) cols(state_) 5:cols(state_)]'./state_[2]))
     ~(ln(   pc_[cols(pc_)    cols(pc_)    5:cols(pc_)]'   ./pc_[2]));
else;      @ growth rates relative to preceding year @
dat_= ys~(crit[i].*ones(rows(ys),1))
     ~(   real_[3:cols(real_)]'                            )
     ~(   nom_[3:cols(nom_)]'                          )
     ~(   state_[3:cols(state_)]'                              )
     ~(   pc_[3:cols(state_)]'                              )
     ~(ln(real_[3:cols(real_)]'./real_[2:(cols(real_)-1)]'))
     ~(ln(nom_[3:cols(nom_)]'./nom_[2:(cols(nom_)-1)]'))
     ~(ln(state_[3:cols(state_)]'./state_[2:(cols(state_)-1)]'))
     ~(ln(pc_[3:cols(pc_)]'./pc_[2:(cols(pc_)-1)]'));
endif;

if i==1; data=dat_; else; data=data|dat_; endif;
endo;

@ format /rd 12,3; data; @

@-----------------------------------------------------------------------@

v=1|2; data=sortmc(data,v); @ year and county @

create f3=^dtset3 with ^vnames,cols(data),8;
call writer(f3,data);
f3=close(f3);

format /rd 10,0; "Number of columns:" cols(data);
format /rd 10,4;
"Minimum values:";
minc(data);
"Maximum values:";
maxc(data);
@ clear f3, data; @

end;
