@ Programm cu9.prg @

/* this file adds the tom codes to the cuacct-file (fourth column);
   it writes a file named merge1;
   deletes cus without tom codes (obsolete, but leave it that way);
   writes merge2 */
/* program does not have to be adjusted if new dataset was pulled;
   simply re-running will do the job */

new; #lineson;
save path=d:\data\cu1\gauss;
output file=c:\prg\cu1\cu9.out reset;
screen on; @ output off; @

dstr=datestr(0); tstr=timestr(0);
cls;
"GAUSS                                   date (US)" dstr;; "  ";; tstr;
?;"input file: cu9.prg";?;

vnames="xx";
dtset3="d:\\data\\cu1\\gauss\\merge1";

@ Lesen der Daten @

dos pkunzip -3 -) d:\data\cu1\gauss\cuacct3.zip c:\prg\cu1;
dtset1="cuacct3";
open f1=^dtset1 for read;
rw1=rowsf(f1);

dos pkunzip -3 -) d:\data\cu1\gauss\cutom2.zip c:\prg\cu1;
dtset2="cutom2";
open f2=^dtset2 for read;
rw2=rowsf(f2);
tco=readr(f2,rw2); @ tom codes @
f2=close(f2);

let sv = 1 1 25 80 0 7; scroll sv; locate 5,1;
"...currently working on merge1...";

step=1e3;
i5=0; i6=0; i8=0; @ i5,i6: Zaehler; nicht aendern @
do until eof(f1);
i5=i5+1; i6=i6+1;

if i6==0 or i6==5; i6=0;
format /rd 6,0; locate 6,1;
1e2.*minc((i5.*step)|rw1)./rw1;; "percent done";
endif;

dat=readr(f1,step);
dat[.,4]=-9.*ones(rows(dat),1); @ set to missing value (important!) @

i7=0;
do while i7<rows(dat);
i7=i7+1;
do while i8<rows(tco);
i8=i8+1;  @ i8 never gets reset because there is only one obs in
            cuacct which uses this observation @
   if     dat[i7,1].<tco[i8,1]; @ year @ i8=i8-1; break; endif;
   if     dat[i7,1].<=tco[i8,1] @ year @
      and dat[i7,3].<tco[i8,2];          i8=i8-1; break; endif;
   if dat[i7,1 3]==tco[i8,1 2]; dat[i7,4]=tco[i8,3];
   @ dat[i7,4]; wait; @
   endif;
endo; @ i8 @
endo; @ i7 @

   @ dat[.,4]'; wait; @
   if     i5==1; create f3=^dtset3 with ^vnames,cols(dat),8;
                 call writer(f3,dat);
                 f3=close(f3);
                 min_=minc(dat); max_=maxc(dat);
   elseif i5==2; open f3=^dtset3 for append; @ file bleibt offen @
                 call writer(f3,dat);
                 min_=minc(min_'|(minc(dat))');
                 max_=maxc(max_'|(maxc(dat))');
   else;         call writer(f3,dat);
                 min_=minc(min_'|(minc(dat))');
                 max_=maxc(max_'|(maxc(dat))');
   endif;

endo; @ read until eof @

f1=close(f1);
f3=close(f3);
clear f1,f3;
clear exvec, dat;

format /rd 12,0;
open f1=^dtset1 for read;
rw1=rowsf(f1);
f1=close(f1);
"orig number of obs:" rw1;

open f3=^dtset3 for read;
rw3=rowsf(f3);
f3=close(f3);
"number of obs left:" rw3;

"minimum vector:" min_;
"maximum vector:" max_;

dos del cutom2.d?t;
dos del cuacct3.d?t;

@------------------------------------------------------------------@

@ eliminate cus without tom code @

dtset4="d:\\data\\cu1\\gauss\\merge2";

open f3=^dtset3 for read;
rw3=rowsf(f3);
i5=0; i6=0; @ i5,i6: Zaehler; nicht aendern @
do until eof(f3);
i6=i6+1;

if i6==0 or i6==5; i6=0;
format /rd 6,0; locate 6,1;
1e2.*minc((i5.*step)|rw3)./rw3;; "percent done";
endif;

dat=readr(f3,step);
@ dat[.,4]'; wait; @

exvec=(dat[.,4].>-1); @ tom codes @

if sumc(exvec).>=1; i5=i5+1;

   dat=selif(dat,exvec);

   if     i5==1; create f4=^dtset4 with ^vnames,cols(dat),8;
                 call writer(f4,dat);
                 f4=close(f4);
                 min_=minc(dat); max_=maxc(dat);
   elseif i5==2; open f4=^dtset4 for append; @ file bleibt offen @
                 call writer(f4,dat);
                 min_=minc(min_'|(minc(dat))');
                 max_=maxc(max_'|(maxc(dat))');
   else;         call writer(f4,dat);
                 min_=minc(min_'|(minc(dat))');
                 max_=maxc(max_'|(maxc(dat))');
   endif;
endif;

endo; @ read until eof @

f3=close(f3);
f4=close(f4);
clear f3,f4;
format /rd 10,0; "number of columns in dataset: " cols(dat);
clear exvec, dat;

format /rd 12,0;
open f3=^dtset3 for read;
rw3=rowsf(f3);
f3=close(f3);
"orig number of obs:" rw3;

open f4=^dtset4 for read;
rw4=rowsf(f4);
f4=close(f4);
"number of obs left:" rw4;

"minimum vector:" min_;
"maximum vector:" max_;

dos pkzip -3 -)  d:\data\cu1\gauss\merge1.zip
           d:\data\cu1\gauss\merge1.d?t;
dos del    d:\data\cu1\gauss\merge1.d?t;
dos pkzip -3 -)  d:\data\cu1\gauss\merge2.zip
           d:\data\cu1\gauss\merge2.d?t;
dos del    d:\data\cu1\gauss\merge2.d?t;

end;
